SystemOrganization addCategory: 'OrbeonBPMCore'!

Exception subclass: #OrbeonBpmException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #BrokenProcessVersionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #EvaluationNotBlockException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #EvaluationNotBooleanException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #FormToProcessDefinitionMappingException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoAnonymousStartException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoCreationPermissionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoProcessNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoSuchActivitytException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoSuchRoleException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

Object subclass: #BpmObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmArtifactDefinition
	instanceVariableNames: 'processDefinition name inTransitions outTransitions roles extendedAttributes defaultTransition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmArtifactDefinition subclass: #BpmActivityDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmActivityDefinition subclass: #BpmAbstractTaskDefinition
	instanceVariableNames: 'loop performers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/31/2015 14:02'!
addPerformer: aBpmParticipantDefinition

	^performers add: aBpmParticipantDefinition! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:08'!
getExpectedResult

	^self extendedValueOf: 'expectedResult' ifAbsent: [OrderedCollection new]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2016 16:03'!
getFirstPerformerIfNone: aBlock

	^performers notEmpty
		ifTrue: [performers first]
		ifFalse: aBlock! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 12:07'!
getFirstPerformerName
	"The receiver answer the name of the first performers if there is no performers answer an empty string"

	^self hasPerformers 
		ifTrue: [performers first name] 
		ifFalse: ['']! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/05/2016 10:18'!
getPreviousFields
	"The receiver answer a collection of fields to show that belong to previous tasks"

	^((self extendedValueOf: 'previousFields' ifAbsent: [^OrderedCollection new]) subStrings: ' ') collect: [:each | each trimBlanks]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:26'!
getRoleForPerformer: aBpmRoleParticipantDefinition
	"The receiver answer the associated <BpmRole> to the participant <aBpmRoleParticipantDefinition>"

	^roles detect: [:each | each name = aBpmRoleParticipantDefinition name] ifNone: [nil]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 13:30'!
hasLoop

	^loop notNil! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 10:16'!
hasPerformers
	"Answer whether or not the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	^performers size > 1! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:13'!
initialize

	super initialize.

	performers := OrderedCollection new.! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 01/19/2016 12:28'!
isGrantedUser: aBpmUser
	"Answer whether or not the user <aBpmUser> is granted in the receiver.
	If there is NO <performers> in the receiver --> check in each role of the receiver if the user <aBpmUser> is granted on it.
	If there is <performers> in the receiver --> check in each role of the user <aBpmUser> and try to mapp it to any <performer> of the receiver. 
		If succeed --> is granted, else --> not granted"

	self hasPerformers 
	ifFalse: [^roles anySatisfy: [:each | each isGranted: aBpmUser]].

	^self performers anySatisfy: [:eachPerformer | | mappedRole |

		mappedRole := aBpmUser roles detect: [:eachRole | (eachRole name = eachPerformer name) and:[eachRole getApplicationName = self applicationName]] 
									ifNone: [nil].

		mappedRole ifNotNil: [mappedRole isGranted: aBpmUser] ifNil: [false].
	]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 09/05/2016 08:17'!
isMultiInstance
	"Answer whether or not the receiver has multi instance behavior.

	false: the process always use the same model/form if the task is executed more than once.
	true: the process create a new model/form if the task is executed more than once "

	^self hasLoop and: [loop isMultiInstance]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:51'!
isTaskDefinition

	^true! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 13:30'!
loop
	^loop! !

!BpmAbstractTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 13:30'!
loop: newValue
	loop := newValue! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/31/2015 13:53'!
performers
	^performers! !

!BpmAbstractTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/31/2015 13:53'!
performers: newValue
	performers := newValue! !

BpmAbstractTaskDefinition subclass: #BpmSubProcessTaskDefinition
	instanceVariableNames: 'subProcessDefinition isEmbedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addSubProcessTask: self! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 11:51'!
createProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"

	^subProcessDefinition createProcessInstance: aBpmUser! !

!BpmSubProcessTaskDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:22'!
drawOn: aJasvgiBpmCanvas at: aPoint

	self isMultiInstance 
	ifFalse: [^aJasvgiBpmCanvas 
						drawSubProcessActivityNamed: name
						at: aPoint 
						extent: 150@60].

	^aJasvgiBpmCanvas 
			drawSubProcessActivityNamed: name 
			at: aPoint
			extent: 150@60! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:11'!
initialize

	super initialize.

	isEmbedded := false.! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:59'!
instanceClass

	^BpmSubProcessTaskInstance! !

!BpmSubProcessTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/26/2016 14:11'!
isEmbedded
	^isEmbedded! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/26/2016 14:11'!
isEmbedded: newValue
	isEmbedded := newValue! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:43'!
isSubprocessDefinition

	^true! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 15:51'!
printNameAndDefinitionType

	^'Subprocess [', self name, ']'! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'S'! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:10'!
setRolesOfUnderlineProcess
	"For embedded sub processes the roles are inherit from the parent task definition.
	Embedded subprocess does not have Lanes --> they 'do not have' roles (roles are inherit)"
	| taskDefRoles |

	self isEmbedded ifFalse: [^self]. "it is only applicable on embedded sub processes"

	"roles of the top process are inherit by all embedded subprocess"
	taskDefRoles := processDefinition getParentTopSubProcessTaskDefinition ifNil: [roles] ifNotNil: [:taskDef | taskDef roles]. 

	(subProcessDefinition getAllArtifacts reject: [:each | each isEventDefinition]) do: [:eachArtifact |  
		taskDefRoles do: [:eachRole | eachArtifact grantRole: eachRole]]! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/27/2016 12:48'!
setSubProcessDefinition: aBpmSubProcessDefinition

	subProcessDefinition := aBpmSubProcessDefinition.

	processDefinition addSubProcess: aBpmSubProcessDefinition! !

!BpmSubProcessTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition
	^subProcessDefinition! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition: newValue
	subProcessDefinition := newValue! !

BpmAbstractTaskDefinition subclass: #BpmTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTaskDefinition subclass: #BpmOrbeonTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 09:22'!
getComponentClass
	"Answer the OrbeonFormDefinition associated with the receiver.
	The name of the task and the name of the OrbeonFormDefinition MUST be the same.
	Also each time a task is created it get the lastest version of the OrbeonFormDefinition "

	^processDefinition application definitionNamed: name ifNone: [nil]! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:13'!
getObjectModel

	^self getComponentClass! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:58'!
instanceClass

	^BpmOrbeonTaskInstance! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:50'!
isOrbeonTask

	^true! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:38'!
printNameAndDefinitionType

	^name, ' [O]'! !

BpmTaskDefinition subclass: #BpmSeasideTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:31'!
getComponentClass
	| seasideComponent |

	seasideComponent := Smalltalk at: (self extendedValueOf: 'seasideComponent' ifAbsent: [^nil]) asSymbol.

	^seasideComponent! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:32'!
getObjectModel

	^self getComponentClass 
			ifNotNil: [:value | value defaultModel]
			ifNil: [nil]! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:59'!
instanceClass

	^BpmSeasideTaskInstance! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:38'!
printNameAndDefinitionType

	^name, ' [C]'! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:43'!
taskName

	^self getObjectModel getObjectName! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addTask: self! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/17/2016 11:22'!
getComponentClass

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 07:51'!
getFieldNames

	^self getComponentClass getFieldsNames! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:13'!
getObjectModel

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:39'!
instanceClass

	^BpmOrbeonTaskInstance! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:37'!
printNameAndDefinitionType

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'T'! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 14:55'!
printSummaryFields
	| stream contents |

	stream := PrintStream on: String new.

	self getComponentClass summaryFields do: [:each | stream nextPutAll: each, ', '].

	contents := stream contents.

	^(contents size = 2) ifTrue: ["empty" ''] ifFalse: [contents allButLast: 2] "removing the last -', '-"! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 14:49'!
summaryFields

	^self getComponentClass summaryFields! !

!BpmActivityDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:23'!
drawOn: aJasvgiBpmCanvas at: aPoint

	self isMultiInstance 
	ifFalse: [^aJasvgiBpmCanvas 
						drawActivityNamed: name
						at: aPoint 
						extent: 150@60].

	^aJasvgiBpmCanvas 
			drawMultiInstaceActivityNamed: name 
			at: aPoint
			extent: 150@60! !

BpmActivityDefinition subclass: #BpmGatewayDefinition
	instanceVariableNames: 'waitAllIncoming'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmGatewayDefinition subclass: #BpmComplexGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmComplexGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(*)
As the name signifies, complex gateways are only used for the most complex flows in the business process. When possible, you should use a simpler gateway to do what needs to be done. If you need multiple gateways to describe the business flow, then that's an ideal case for the complex gateway. Complex gateways need more descriptive text because you're using words in place of symbols.

Splitting: the flow will go down one or more paths depending on the evaluation of a single condition specified for the Gateway. 

Merging: the Gateway synchronizes all incoming paths that meet a single condition specified for the Gateway.!

!BpmComplexGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/23/2015 13:40'!
createInstanceOn: aBpmProcessInstance

	^(self instanceClass definition: self)
		process: aBpmProcessInstance;
		yourself! !

!BpmComplexGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:40'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmComplexGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:36'!
instanceClass

	^BpmComplexGateway! !

BpmGatewayDefinition subclass: #BpmEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
Splitting: the flow goes down only one of the paths that originate in the Gateway depending on the occurrence of a specified Event. 

Merging: it has the same behavior as the Exclusive Gateway.!

!BpmEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
An event-based gateway is similar to a exclusive gateway because both involve one path in the flow. In the case of an event-based gateway, however, you are evaluating which event has occurred, not which condition is being met.!

!BpmExclusiveEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(X)
An exclusive gateway evaluates the state of the business process andbased on the conditionbreaks the flow into one of the two or more mutually exclusive paths. Remember that the exclusive in "exclusive gateway" stands for mutually exclusive.

Splitting: the flow will go down only one of the paths that originate in the Gateway; the selection will be made after evaluating the conditions defined for the Gateway (there will be one per each path). 

Merging: when multiple paths reach the Gateway, it simply allows the flow to continue without evaluating any conditions or making any synchronization.!

!BpmExclusiveGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 01/22/2016 12:15'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmExclusiveGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 11:06'!
drawOn: aJasvgiBpmCanvas at: aPoint
	" ''-empty string = 'Exclusive' "

	^aJasvgiBpmCanvas drawGatewayType: '' at: aPoint id: name color: 'lightgray'! !

!BpmExclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmExclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveGateway! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addGateway: self! !

!BpmGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/24/2015 13:31'!
createNewGatewayOn: aBpmProcessInstance
	| newGateway |

	newGateway := (self instanceClass definition: self)
								process: aBpmProcessInstance;
								yourself.

	aBpmProcessInstance startGateway: newGateway. "add the gateway to running gateways collection"

	^newGateway! !

!BpmGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:24'!
drawFirstOn: aJasvgiBpmCanvas

	^self drawOn: aJasvgiBpmCanvas at: 10@20! !

!BpmGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:24'!
drawLastOn: aJasvgiBpmCanvas

	^self drawOn: aJasvgiBpmCanvas at: 250@20! !

!BpmGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 11:01'!
drawOn: aJasvgiBpmCanvas at: aPoint

	^aJasvgiBpmCanvas drawGatewayType: 'Inclusive' at: aPoint id: name color: 'lightgray'! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:21'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"

	^outTransitions anySatisfy: [:each | each hasEvaluationConditionWithFieldNamed: fieldName]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 12:59'!
isGateway

	^true! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:18'!
isMerging
	"Answer whether or not the receiver is merging the process path"

	^(inTransitions size > 1) and: [outTransitions size = 1]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:19'!
isSplitting
	"Answer whether or not the receiver is splitting the process path"

	^(inTransitions size = 1) and: [outTransitions size > 1]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'G'! !

!BpmGatewayDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2015 13:34'!
waitAllIncoming
	^waitAllIncoming! !

!BpmGatewayDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/23/2015 13:34'!
waitAllIncoming: newValue
	waitAllIncoming := newValue! !

BpmGatewayDefinition subclass: #BpmInclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmInclusiveGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(O)
An inclusive gateway breaks the process flow into one or more flows. An example of a inclusive gateway is business actions taken based on survey results.

Splitting: the flow will go down all the outgoing paths that meet the Gateways conditions (there will be one per each path). 

Merging: it synchronizes all the paths where the process flow effectively reaches the gateway.!

!BpmInclusiveGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 01/23/2016 13:33'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmInclusiveGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 11:03'!
drawOn: aJasvgiBpmCanvas at: aPoint

	^aJasvgiBpmCanvas drawGatewayType: 'Inclusive' at: aPoint id: name color: 'lightgray'! !

!BpmInclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!BpmInclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:40'!
instanceClass

	^BpmInclusiveGateway! !

BpmGatewayDefinition subclass: #BpmParallelEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
As the name suggest, this gateway is similar to a parallel gateway. It allows for multiple processes to happen at the same time, but unlike the parallel gateway, the processes are event dependent.!

!BpmParallelEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^self subclassResponsibility! !

BpmGatewayDefinition subclass: #BpmParallelGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(+)
A parallel gateway is very different than the previous gateways because you aren't evaluating any condition or event. Instead, parallel gateways are used to represent two concurrent tasks in a business flow.

Splitting: the flow will go down all the paths originated in the Gateway. 

Merging: it synchronizes all the paths that arrive to the Gateway!

!BpmParallelGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 12/05/2016 11:04'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmParallelGatewayDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 11:06'!
drawOn: aJasvgiBpmCanvas at: aPoint

	^aJasvgiBpmCanvas drawGatewayType: 'Parallel' at: aPoint id: name color: 'lightgray'! !

!BpmParallelGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:39'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!BpmParallelGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:38'!
instanceClass

	^BpmParallelGateway! !

BpmActivityDefinition subclass: #BpmScriptTaskDefinition
	instanceVariableNames: 'scriptCode loop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmScriptTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:45'!
addToParentProcess

	^processDefinition addScript: self! !

!BpmScriptTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 06/24/2016 09:51'!
instanceClass

	^BpmScriptTaskInstance! !

!BpmScriptTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/22/2016 11:04'!
loop
	^loop! !

!BpmScriptTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/22/2016 11:04'!
loop: newValue
	loop := newValue! !

!BpmScriptTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 12:27'!
scriptCode
	^scriptCode! !

!BpmScriptTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 12:27'!
scriptCode: newValue
	scriptCode := newValue! !

!BpmArtifactDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:41'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:23'!
addInTransition: aBpmTransitionDefinition

	^inTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 13:15'!
addOutTransition: aBpmTransitionDefinition
	"The receiver add transition <aBpmTransitionDefinition> as an OUTgoing transition.
	If the transition is the default flow then set it."

	aBpmTransitionDefinition isDefaultFlow ifTrue: [self defaultTransition: aBpmTransitionDefinition].

	^outTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:21'!
addToParentProcess

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:47'!
applicationName

	^processDefinition applicationName! !

!BpmArtifactDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/23/2015 08:47'!
createInstanceOn: aBpmProcessInstance

	^(self instanceClass definition: self)
		process: aBpmProcessInstance;
		yourself! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 07/01/2016 06:10'!
defaultTransition
	^defaultTransition! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 07/01/2016 06:10'!
defaultTransition: newValue
	defaultTransition := newValue! !

!BpmArtifactDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 10:22'!
drawFirstOn: aJasvgiBpmCanvas

	^self drawOn: aJasvgiBpmCanvas at: 10@10! !

!BpmArtifactDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 10:30'!
drawLastOn: aJasvgiBpmCanvas

	^self drawOn: aJasvgiBpmCanvas at: 250@10! !

!BpmArtifactDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 10:53'!
drawOn: aJasvgiBpmCanvas at: aPoint

	self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:37'!
extendedAttributes
	^extendedAttributes! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:37'!
extendedAttributes: newValue
	extendedAttributes := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
extendedValueOf: attrName

	^extendedAttributes at: attrName ifAbsent: [nil]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
extendedValueOf: attrName ifAbsent: aBlock

	^extendedAttributes at: attrName ifAbsent: aBlock! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 07:51'!
getFieldNames

	^#()! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 11:40'!
getPreviousFields
	^#()! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:28'!
grantRole: aBpmRole

	aBpmRole addResponsibility: self.

	^roles add: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 10:17'!
hasPerformers
	"Answer whether or not the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:37'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.
	roles := OrderedCollection new.

	extendedAttributes := Dictionary new.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:34'!
instanceClass

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions
	^inTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions: newValue
	inTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 15:10'!
isEndEvent

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:12'!
isEventDefinition

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 12:59'!
isGateway

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 05:54'!
isGrantedRole: aBpmRole

	^roles includes: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
isGrantedRoleNamed: aString

	^roles anySatisfy: [:each | each name = aString]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:49'!
isGrantedUser: aBpmUser
	"Answer whether or not the user <aBpmUser> is granted in the receiver"

	^roles anySatisfy: [:each | each isGranted: aBpmUser]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 09:08'!
isMultiInstance

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:50'!
isOrbeonTask

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:43'!
isSubprocessDefinition

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:51'!
isTaskDefinition

	^false! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
name
	^name! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
name: newValue
	name := newValue! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions
	^outTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions: newValue
	outTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2016 15:06'!
performers

	^#()! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 15:43'!
printInArtifacts
	| stream |

	inTransitions ifEmpty: [^''].

	stream := PrintStream on: String new.

	inTransitions do: [:each | stream nextPutAll: each printStartArtifactName, ' | '].

	^stream contents allButLast: 3! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:42'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' (', self printOnType, ') [', name asString, ']'.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:13'!
printOnType

	^'Art'! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 15:43'!
printOutArtifacts
	| stream |

	outTransitions ifEmpty: [^''].

	stream := PrintStream on: String new.

	outTransitions do: [:each | stream nextPutAll: each printEndArtifactName, ' | '].

	^stream contents allButLast: 3! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 07:52'!
printRoleNames
	| names |

	roles ifEmpty: [^''].

	names := ''.
	roles do: [:each | names := names, each name, ' | ' ].

	^names allButLast: 3! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 14:55'!
printSummaryFields

	^''! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition
	^processDefinition! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:48'!
processDefinitionName

	^processDefinition processName! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
removeExtendedAttribute: attrName 

	^extendedAttributes removeKey: attrName ifAbsent: []! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:22'!
roles
	^roles! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:22'!
roles: newValue
	roles := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 12:55'!
setExtendedAttribute: attrName value: anObject

	^extendedAttributes at: attrName put: anObject! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 14:49'!
summaryFields

	^#()! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 02/18/2016 12:02'!
taskName

	^name! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:10'!
ungrantAllRoles
		"The receiver ungrant all roles "

		roles do: [:each | each removeResponsibility: self].

		roles := OrderedCollection new.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:21'!
ungrantRole: aBpmRole

	aBpmRole removeResponsibility: self.

	^roles remove: aBpmRole 
				ifAbsent: [NoSuchRoleException signal: 'The receiver has no such a role name [', aBpmRole name, ']']! !

BpmArtifactDefinition subclass: #BpmEventDefinition
	instanceVariableNames: 'cycle type tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEventDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:41'!
addToParentProcess

	^cycle addToParentProcess! !

!BpmEventDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:27'!
cycle
	^cycle! !

!BpmEventDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:27'!
cycle: newValue
	cycle := newValue! !

!BpmEventDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:26'!
drawFirstOn: aJasvgiBpmCanvas

	self isEndEvent ifTrue: [^self drawOn: aJasvgiBpmCanvas at: 10@25].

	^self drawOn: aJasvgiBpmCanvas at: 20@25! !

!BpmEventDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:25'!
drawLastOn: aJasvgiBpmCanvas

	self isEndEvent ifTrue: [^self drawOn: aJasvgiBpmCanvas at: 250@25].

	^self drawOn: aJasvgiBpmCanvas at: 250@25! !

!BpmEventDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/05/2016 13:16'!
drawOn: aJasvgiBpmCanvas at: aPoint

	self isEndEvent ifTrue: [^aJasvgiBpmCanvas drawEndNamed: name at: aPoint].

	^aJasvgiBpmCanvas drawStartNamed: name at: aPoint! !

!BpmEventDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:42'!
instanceClass

	^cycle instanceClass! !

!BpmEventDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:50'!
isEndEvent

	^cycle isEndEvent! !

!BpmEventDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:12'!
isEventDefinition

	^true! !

!BpmEventDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:46'!
printOnType

	^cycle printOnType! !

!BpmEventDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:27'!
tag
	^tag! !

!BpmEventDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:27'!
tag: newValue
	tag := newValue! !

!BpmEventDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:27'!
type
	^type! !

!BpmEventDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:27'!
type: newValue
	type := newValue! !

BpmObject subclass: #BpmCodeAnalyzer
	instanceVariableNames: 'blockCode codeWarnings parser infoWarnings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:33'!
example1
	"
BpmCodeAnalyzer example1
"
	^(super new blockCode: '[:form | MyClass resetAll. form class removeAll]')
		analyze
		codeWarnings.! !

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:33'!
example2
	"
BpmCodeAnalyzer example2
"
	^(super new blockCode: '[:form | form age > 10 and:[form amount = 3 or:[form type = ''28'']]. Compiler compile: ''lajdflasj'']')
		analyze
		codeWarnings.! !

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:30'!
for: blockCode

	^super new initialize
		blockCode: blockCode;
		yourself! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:31'!
addBlockWarning: aString

	^codeWarnings add: aString! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 08/02/2016 14:14'!
addInfo: aString

	^infoWarnings add: aString! !

!BpmCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:53'!
analyze

	self subclassResponsibility! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
blockCode
	^blockCode! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 13:19'!
blockCode: blockOrString

	blockCode := (blockOrString isKindOf: String) ifTrue: [blockOrString] ifFalse: [blockOrString method _sourceStringForBlock].
	parser := [RBParser parseExpression: blockCode] on: Error do: [:err | self addBlockWarning: err description].! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
codeWarnings
	^codeWarnings! !

!BpmCodeAnalyzer methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 10:31'!
codeWarnings: newValue
	codeWarnings := newValue! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 15:14'!
getOrbeonFormInstanceClassOrNil
	"This method is implemented in this way to make BPM package independent of the Orbeon package"

	^Smalltalk at: #OrbeonFormInstance ifAbsent: [nil]! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:32'!
hasWarinings

	^codeWarnings notEmpty! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 08/02/2016 14:13'!
infoWarnings
	^infoWarnings! !

!BpmCodeAnalyzer methodsFor: 'Updating' stamp: 'BrunoBB 08/02/2016 14:13'!
infoWarnings: newValue
	infoWarnings := newValue! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 08/02/2016 14:14'!
initialize

	super initialize.
	
	codeWarnings := OrderedCollection new.
	infoWarnings := OrderedCollection new.! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
parser
	^parser! !

!BpmCodeAnalyzer methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 10:31'!
parser: newValue
	parser := newValue! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:53'!
printCodeWarnings
	| stream |

	stream := PrintStream on: String new.

	codeWarnings do: [:each | stream nextPutAll: each; nextPutAll: String lf].

	^stream contents! !

BpmCodeAnalyzer subclass: #BpmGatewayConditionCodeAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:53'!
analyze

	parser isBlock ifFalse: [^self addBlockWarning: 'Condition is NOT a Block'; yourself].

	self checkOneArgumentBlockRule; "check the block has only one argument"
		checkReceiverVariableRule; "check that all receivers are the block argument or a basic class (Date, Time, TimeStamp)"
		checkReceiverVariableMessagesRule! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:47'!
checkOneArgumentBlockRule
	"Receiver's block must be a ONE argument block"

	(parser arguments size = 0) 
	ifTrue: [^self addBlockWarning: 'Block has no argument'].

	(parser arguments size > 1) 
	ifTrue: [^self addBlockWarning: 'Block has more than one argument'].! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:48'!
checkReceiverVariableMessagesRule
	"All messages sent to Block's argument MUST be NOT understand by <BpmProcessInstance> and <OrbeonFormInstance>.
	Inside the block messages are sent only to fields of <OrbeonFormInstance> or <BpmProcessInstance> and this messages are dispatched using #doesNotUnderstand:. 
	So inside the block message to the argument MUST fail "
	| atomicMessages notPerfomMessages perfomMessages |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	notPerfomMessages := atomicMessages select: [:each | (each selector findString: #perform:) = 0]. "not perform messages"
	perfomMessages := atomicMessages select: [:each | (each selector findString: #perform:) ~= 0]. "perform messages"

	(notPerfomMessages select: [:each | 
		(self getOrbeonFormInstanceClassOrNil 
		ifNotNil: [:value | self isInvalidSelector: each selector for: value] ifNil: [false]) 
		or: [self isInvalidSelector: each selector for: BpmProcessInstance]]) 
			do: [:each | self addBlockWarning: 'Valid message [', each selector,'] is sent to Form or Process.'].

	"Check form #perform: with more that one argument, NOT allowed only a string with a field name is allowed for message #perform: "
	(perfomMessages select: [:each | each arguments size > 1]) do: [:each | self addBlockWarning: 'Perform message sent with more than one argument.'].

	"Check for suspicious string as argument of #perform: message, more than one string (subString: space) as argument of #perform: NOT allowed"
	(perfomMessages select: [:each | (each arguments size = 1) and: [each arguments last token isLiteralToken and: [(each arguments last value subStrings: ' ') size > 1]]]) do: [:each | self addBlockWarning: 'Suspicious string inside #perform: message']! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:49'!
checkReceiverVariableRule
	"All basic receivers (receiver isVariable) MUST send message only to Block argument.
	If a message is sent to a <variable receiver> and this <variable receiver> is not the block argument then it can be malicious code or an error"
	| atomicMessages argumentName |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	(parser arguments size = 1) ifFalse: [^self]."if arguments size is not correct --> we abort the following checks"

	argumentName := parser arguments last name. "the name of the Block argument ('each', 'proc' or whatever)"

	(atomicMessages select: [:each | 
			(each receiver name ~= argumentName) "sending a message to anObject different from Block argument ?"
			and:[(self getBasicClasses includes: each receiver name) not "sending message to basic objects ? Time/Date/TimeStamp"
					or:[(self getBasicSelectorsForBasicClasses includes: each selector) not]]]) 
	do: [:each | self addBlockWarning: 'Message is sent to object [', each receiver name, '] that is NOT the argument of the Block or it is a forbidden message [', each selector, '].' ]! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 06/25/2016 07:50'!
getAllowedSelectorsToBlockArgument
	"Answer a collection with valid selectors that can be sent to the argument of the Block to be evaluated.

	See: BpmProcessInstance>>getValueOf:"

	^#(#getValueOf:)! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 06/25/2016 07:50'!
getBasicClasses

	^#('Date' 'Time' 'TimeStamp')! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 06/25/2016 07:51'!
getBasicSelectorsForBasicClasses

	^#(#fromString: #now #today)! !

!BpmGatewayConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 06/25/2016 07:51'!
isInvalidSelector: selector for: anObject
	"Answer whether or not the selector <selector> is valid message to sent to object <anObject>"

	^(self getAllowedSelectorsToBlockArgument includes: selector) not and:[anObject canUnderstand: selector]! !

BpmCodeAnalyzer subclass: #BpmProcessConditionCodeAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 11/13/2016 12:26'!
analyze

	parser isBlock ifFalse: [^self addBlockWarning: 'Condition is NOT a Block'; yourself].

	self checkOneArgumentBlockRule; "check the block has only one argument"
		checkReceiverVariableRule; "check that all receivers are the block argument or a basic class (Date, Time, TimeStamp)"
		checkReceiverVariableMessagesRule! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 11/13/2016 12:26'!
checkOneArgumentBlockRule
	"Receiver's block must be a ONE argument block"

	(parser arguments size = 0) 
	ifTrue: [^self addBlockWarning: 'Block has no argument'].

	(parser arguments size > 1) 
	ifTrue: [^self addBlockWarning: 'Block has more than one argument'].! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 11/13/2016 12:26'!
checkReceiverVariableMessagesRule
	"All messages sent to Block's argument MUST be NOT understand by <BpmProcessInstance> and <OrbeonFormInstance>.
	Inside the block messages are sent only to fields of <OrbeonFormInstance> or <BpmProcessInstance> and this messages are dispatched using #doesNotUnderstand:. 
	So inside the block message to the argument MUST fail "
	| atomicMessages notPerfomMessages perfomMessages |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	notPerfomMessages := atomicMessages select: [:each | (each selector findString: #perform:) = 0]. "not perform messages"
	perfomMessages := atomicMessages select: [:each | (each selector findString: #perform:) ~= 0]. "perform messages"

	(notPerfomMessages select: [:each | 
		(self getOrbeonFormInstanceClassOrNil 
		ifNotNil: [:value | self isInvalidSelector: each selector for: value] ifNil: [false]) 
		or: [self isInvalidSelector: each selector for: BpmProcessInstance]]) 
			do: [:each | self addBlockWarning: 'Valid message [', each selector,'] is sent to Form or Process.'].

	"Check form #perform: with more that one argument, NOT allowed only a string with a field name is allowed for message #perform: "
	(perfomMessages select: [:each | each arguments size > 1]) do: [:each | self addBlockWarning: 'Perform message sent with more than one argument.'].

	"Check for suspicious string as argument of #perform: message, more than one string (subString: space) as argument of #perform: NOT allowed"
	(perfomMessages select: [:each | (each arguments size = 1) and: [each arguments last token isLiteralToken and: [(each arguments last value subStrings: ' ') size > 1]]]) do: [:each | self addBlockWarning: 'Suspicious string inside #perform: message']! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 11/13/2016 12:26'!
checkReceiverVariableRule
	"All basic receivers (receiver isVariable) MUST send message only to Block argument.
	If a message is sent to a <variable receiver> and this <variable receiver> is not the block argument then it can be malicious code or an error"
	| atomicMessages argumentName |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	(parser arguments size = 1) ifFalse: [^self]."if arguments size is not correct --> we abort the following checks"

	argumentName := parser arguments last name. "the name of the Block argument ('each', 'proc' or whatever)"

	(atomicMessages select: [:each | 
			(each receiver name ~= argumentName) "sending a message to anObject different from Block argument ?"
			and:[(self getBasicClasses includes: each receiver name) not "sending message to basic objects ? Time/Date/TimeStamp"
					or:[(self getBasicSelectorsForBasicClasses includes: each selector) not]]]) 
	do: [:each | self addBlockWarning: 'Message is sent to object [', each receiver name, '] that is NOT the argument of the Block or it is a forbidden message [', each selector, '].' ]! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 11/13/2016 12:26'!
getAllowedSelectorsToBlockArgument
	"Answer a collection with valid selectors that can be sent to the argument of the Block to be evaluated.

	See: BpmProcessInstance>>getValueOf:"

	^#(#getValueOf:)! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 11/13/2016 12:26'!
getBasicClasses

	^#('Date' 'Time' 'TimeStamp')! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code exceptions' stamp: 'BrunoBB 11/13/2016 12:26'!
getBasicSelectorsForBasicClasses

	^#(#fromString: #now #today)! !

!BpmProcessConditionCodeAnalyzer methodsFor: 'code analyzer' stamp: 'BrunoBB 11/13/2016 12:26'!
isInvalidSelector: selector for: anObject
	"Answer whether or not the selector <selector> is valid message to sent to object <anObject>"

	^(self getAllowedSelectorsToBlockArgument includes: selector) not and:[anObject canUnderstand: selector]! !

BpmCodeAnalyzer subclass: #BpmTaskScriptCodeAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTaskScriptCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 07:58'!
analyze

	parser isBlock ifFalse: [^self addBlockWarning: 'Condition is NOT a Block'; yourself].

	self checkTwoArgumentBlockRule.! !

!BpmTaskScriptCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 07:57'!
checkTwoArgumentBlockRule
	"Receiver's block must be a TWO argument block.
	[:process :script | ...  ]"

	(parser arguments size = 0) 
	ifTrue: [^self addBlockWarning: 'Block has no argument'].

	(parser arguments size ~= 2) 
	ifTrue: [^self addBlockWarning: 'Block does not have two arguments'].! !

BpmObject subclass: #BpmCodeCondition
	instanceVariableNames: 'evaluationCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmCodeCondition class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:10'!
code: aString

	^super new initialize
		evaluationCode: aString;
		yourself! !

!BpmCodeCondition class methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 09:32'!
fromBlock: aBlock

	^super new initialize
		evaluationCode: aBlock;
		yourself! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:51'!
evaluateConditionIn: blockArgumentObject
	"The receiver evaluates the condition <conditionToRun> in the context of the object <blockArgumentObject>"
	| evaluation blockClosure blockEvaluation |

	evaluation := BpmCodeEvaluationResult new.

	[ 	blockClosure := (evaluationCode class == String) 
			ifTrue: [self evaluate: evaluationCode] 
			ifFalse: [evaluationCode]. "at this point the <evaluationCode> should be <aBlockClosure> otherwise it will set an exception in the receiver" 
		blockEvaluation := blockClosure value: blockArgumentObject.
		evaluation result: blockEvaluation] on: Error do:[:error | evaluation exception: error].

	"evaluation does not raised anException but the result is NOT a boolean value"
	(evaluation hasNoException and: [evaluation resultNotBoolean]) 
	ifTrue: [evaluation exception: EvaluationNotBooleanException new].

	"the variable <blockClosure> MUST BE a BlockClosure because the <condition> could be a valid Smalltalk expression but NOT a block"
	blockClosure isBlock
	ifFalse: [evaluation exception: EvaluationNotBlockException new].

	^evaluation! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:50'!
evaluateConditionIn2: blockArgumentObject
	"The receiver evaluates the condition <conditionToRun> in the context of the object <blockArgumentObject>"
	| evaluation blockClosure blockEvaluation |

	evaluation := BpmCodeEvaluationResult new.

	[ 	blockClosure := (evaluationCode class == String) 
			ifTrue: [self evaluate: evaluationCode] 
			ifFalse: [evaluationCode]. "at this point the <evaluationCode> should be <aBlockClosure> otherwise it will set an exception in the receiver" 
		blockEvaluation := blockClosure value: blockArgumentObject.
		evaluation result: blockEvaluation] on: Error do:[:error | evaluation exception: error].

	"evaluation does not raised anException but the result is NOT a boolean value"
	(evaluation hasNoException and: [evaluation resultNotBoolean]) 
	ifTrue: [evaluation exception: EvaluationNotBooleanException new].

	"the variable <blockClosure> MUST BE a BlockClosure because the <condition> could be a valid Smalltalk expression but NOT a block"
	blockClosure isBlock
	ifFalse: [evaluation exception: EvaluationNotBlockException new].

	^evaluation! !

!BpmCodeCondition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode
	^evaluationCode! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode: newValue
	evaluationCode := newValue! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 07:00'!
hasEvaluation

	^evaluationCode notNil and: [evaluationCode notEmpty]! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:18'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"
	| parser messagesToProcess |

	evaluationCode ifNil: [^false].

	parser := RBParser parseExpression: evaluationCode.

	messagesToProcess := parser allChildren select: [:each | each isMessage and:[each receiver isVariable]].

	^messagesToProcess anySatisfy: [:each | each selector asString = fieldName asString]! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 09:42'!
printEvaluationCode

	evaluationCode ifNil: [^'none'].

	evaluationCode isBlock ifTrue: [^evaluationCode blockSource]. 
	
	^evaluationCode! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:27'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '{', self printEvaluationCode, '}'! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 09:43'!
value: blockArgumentObject
	"The receiver evaluates the condition <conditionToRun> in the context of the object <blockArgumentObject>"

	^(self evaluateConditionIn: blockArgumentObject) result! !

BpmObject subclass: #BpmEventComponentDefinition
	instanceVariableNames: 'eventDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmEventComponentDefinition subclass: #BpmCycleComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmCycleComponentDefinition subclass: #BpmEndComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEndComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 15:01'!
addToParentProcess

	^self processDefinition addEndEvent: eventDefinition! !

!BpmEndComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:50'!
instanceClass

	^BpmEndEventInstance! !

!BpmEndComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:50'!
isEndEvent

	^true! !

!BpmEndComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:47'!
printOnType

	^'ev:end'! !

BpmCycleComponentDefinition subclass: #BpmIntermediateComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmIntermediateComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 15:01'!
addToParentProcess

	^self processDefinition addIntermediateEvent: eventDefinition! !

!BpmIntermediateComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:52'!
instanceClass

	^BpmIntermediateEventInstance! !

!BpmIntermediateComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:47'!
printOnType

	^'ev:inter'! !

BpmCycleComponentDefinition subclass: #BpmStartComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStartComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:42'!
addToParentProcess

	^self processDefinition startEvent: eventDefinition! !

!BpmStartComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:43'!
instanceClass

	^BpmStartEventInstance! !

!BpmStartComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:46'!
printOnType

	^'ev:start'! !

!BpmEventComponentDefinition class methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:33'!
event: aBpmEventDefinition

	^super new initialize
		eventDefinition: aBpmEventDefinition;
		yourself! !

!BpmEventComponentDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:33'!
eventDefinition
	^eventDefinition! !

!BpmEventComponentDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:33'!
eventDefinition: newValue
	eventDefinition := newValue! !

!BpmEventComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:50'!
isEndEvent

	^false! !

!BpmEventComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 15:03'!
name

	^eventDefinition name! !

!BpmEventComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:40'!
processDefinition

	^eventDefinition processDefinition! !

BpmEventComponentDefinition subclass: #BpmTagComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTagComponentDefinition subclass: #BpmBoundaryTagComponentDefinition
	instanceVariableNames: 'isNonInterrupt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmBoundaryTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:11'!
beInterrupt

	isNonInterrupt := false.! !

!BpmBoundaryTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:11'!
beNonInterrupt

	isNonInterrupt := true.! !

!BpmBoundaryTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:11'!
initialize

	super initialize.

	isNonInterrupt := true.! !

!BpmBoundaryTagComponentDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:11'!
isNonInterrupt
	^isNonInterrupt! !

!BpmBoundaryTagComponentDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:11'!
isNonInterrupt: newValue
	isNonInterrupt := newValue! !

BpmTagComponentDefinition subclass: #BpmCatchTagComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTagComponentDefinition subclass: #BpmEventSubprocessTagComponentDefinition
	instanceVariableNames: 'isNonInterrupt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEventSubprocessTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:09'!
beInterrupt

	isNonInterrupt := false.! !

!BpmEventSubprocessTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:09'!
beNonInterrupt

	isNonInterrupt := true.! !

!BpmEventSubprocessTagComponentDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 14:09'!
initialize

	super initialize.

	isNonInterrupt := true.! !

!BpmEventSubprocessTagComponentDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2016 14:09'!
isNonInterrupt
	^isNonInterrupt! !

!BpmEventSubprocessTagComponentDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2016 14:09'!
isNonInterrupt: newValue
	isNonInterrupt := newValue! !

BpmTagComponentDefinition subclass: #BpmNormalTagComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTagComponentDefinition subclass: #BpmThrowTagComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmEventComponentDefinition subclass: #BpmTypeComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmCancelComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmCompensationComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmConditionalComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmErrorComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmEscalationComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmLinkComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmMessageComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmMultipleComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmMultipleParallelComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmNoneComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmSignalComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmTerminationComponentDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTypeComponentDefinition subclass: #BpmTimerComponentDefinition
	instanceVariableNames: 'activationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTimerComponentDefinition commentStamp: '' prior: 0!
activationBlock - is a two argument block.

[:lastExecuteTime :currentTime | ]

Where <lastExecuteTime> is given by BpmArtifactInstance <creationTime> (a new BpmEventInstance is created each time the event is triggered so #creationTime is equal to "last executed time").

<currentTime> in most cases it will be equal to <TimeStamp now> but an argument was added to have more flexibility.!

!BpmTimerComponentDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/28/2016 08:47'!
activationBlock
	^activationBlock! !

!BpmTimerComponentDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/28/2016 08:47'!
activationBlock: newValue
	activationBlock := newValue! !

BpmObject subclass: #BpmExceptionCalendar
	instanceVariableNames: 'name days hours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExceptionCalendar class methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 09:59'!
newExeceptWeekEnds
	| calendar |

	calendar := self new initialize.


	^calendar! !

!BpmExceptionCalendar methodsFor: 'adding exception' stamp: 'BrunoBB 02/02/2017 03:56'!
addExceptionDay: aDate
	"The receiver add the date <aDate> to the exception days collection.
	This date <aDate> is NOT going to be counted in processes execution time."

	^days add: aDate! !

!BpmExceptionCalendar methodsFor: 'adding exception' stamp: 'BrunoBB 02/02/2017 08:14'!
addExceptionTimeFrom: startTime to: endTime
	"The receiver add a time interval <startTime> to <endTime> to the exception hours collection.
	This time interval is NOT going to be counted in processes execution time."

	(self hasExceptionDays and: [self timeIntervalExistFrom: startTime to: endTime]) ifTrue: [^Array with: startTime with: endTime].

	^hours add: (Array with: startTime with: endTime)! !

!BpmExceptionCalendar methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2017 03:48'!
days
	^days! !

!BpmExceptionCalendar methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2017 03:48'!
days: newValue
	days := newValue! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 07:24'!
exceptionDaysSize

	^days size! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 07:24'!
exceptionHoursSize

	^hours size! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 07:22'!
hasExceptionDays

	^days notEmpty! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 07:23'!
hasExceptionHours

	^hours notEmpty! !

!BpmExceptionCalendar methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2017 03:48'!
hours
	^hours! !

!BpmExceptionCalendar methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2017 03:48'!
hours: newValue
	hours := newValue! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 03:52'!
initialize

	super initialize.

	name := ''.
	days := Set new.
	hours := OrderedCollection new.! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 07:30'!
isExceptionDay: aDate
	"Answer whether or not the date <aDate> is an exception"

	^days includes: aDate! !

!BpmExceptionCalendar methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2017 03:48'!
name
	^name! !

!BpmExceptionCalendar methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2017 03:48'!
name: newValue
	name := newValue! !

!BpmExceptionCalendar methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 03:53'!
removeExceptionDay: aDate

	^days remove: aDate ifAbsent: []! !

!BpmExceptionCalendar methodsFor: 'adding exception' stamp: 'BrunoBB 02/02/2017 08:31'!
timeIntervalExistFrom: startTime to: endTime
	"The receiver answer whether or not the time interval <startTime> to: <endTime> already exist"
	| newInterval |

	newInterval := Interval from: startTime hours to: endTime hours.

	hours do: [:intervalArray | | currentIterval |
		currentIterval := Interval from: intervalArray first hours to: intervalArray second hours.
		(currentIterval intersection: newInterval) notEmpty ifTrue: [^true].
	].

	^false! !

BpmObject subclass: #BpmExpectedExecutionTime
	instanceVariableNames: 'value calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmExpectedExecutionTime subclass: #BpmExpectedExecutionInDays
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExpectedExecutionInDays methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 04:43'!
calculateExecutionTimeFrom: aTimeValue
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <today>.
	It use it's calendar to whether or not compute a particular time"

	^self calculateExecutionTimeFrom: aTimeValue to: Date today! !

!BpmExpectedExecutionInDays methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 04:15'!
calculateExecutionTimeFrom: startDate to: endDate
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <endTimeValue>.
	It use it's calendar to whether or not compute a particular day"
	| currentDate daysCount |
	
	currentDate := startDate.
	daysCount := 0.

	[currentDate <= endDate] whileTrue: [
		(calendar isExceptionDay: currentDate) ifFalse: [daysCount := daysCount + 1].
		currentDate := currentDate addDays: 1.
	].

	^daysCount! !

BpmExpectedExecutionTime subclass: #BpmExpectedExecutionInHours
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExpectedExecutionInHours methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 04:44'!
calculateExecutionTimeFrom: aTimeValue
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <today>.
	It use it's calendar to whether or not compute a particular time"

	^self calculateExecutionTimeFrom: aTimeValue to: TimeStamp now! !

!BpmExpectedExecutionInHours methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 07:07'!
calculateExecutionTimeFrom: startTimeStamp to: endTimeStamp
	"The receiver calculate (count) the execution time from start time <startTimeStamp> to end time <endTimeStamp>.
	It use it's calendar to whether or not compute a hour"
	| currentTimeStamp hoursCount |
	
	currentTimeStamp := startTimeStamp.
	hoursCount := 0.

	[currentTimeStamp < endTimeStamp] whileTrue: [
		(calendar timeIntervalExistFrom: currentTimeStamp to: (currentTimeStamp plusSeconds: 3600 "1hour")) 
			ifFalse: [hoursCount := hoursCount + 1]. 

		currentTimeStamp := currentTimeStamp plusSeconds: 3600.
	].

	(currentTimeStamp = endTimeStamp and: [(calendar timeIntervalExistFrom: (currentTimeStamp plusSeconds: 60) to: (currentTimeStamp plusSeconds: 60))])
	ifTrue: [hoursCount := hoursCount + 1]. "border case. because above condition loop {currentTimeStamp < endTimeStamp} "

	^hoursCount! !

BpmExpectedExecutionTime subclass: #BpmExpectedExecutionInMinutes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExpectedExecutionInMinutes methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 07:45'!
calculateExecutionTimeFrom: aTimeValue
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <today>.
	It use it's calendar to whether or not compute a particular time"

	^self calculateExecutionTimeFrom: aTimeValue to: TimeStamp now! !

!BpmExpectedExecutionInMinutes methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 09:47'!
calculateExecutionTimeFrom: startTimeStamp to: endTimeStamp
	"The receiver calculate (count) the execution time from start time <startTimeStamp> to end time <endTimeStamp>.
	It use it's calendar to whether or not compute a minute"
	| currentTimeStamp minutesCount |
	
	currentTimeStamp := startTimeStamp.
	minutesCount := 0.

	[currentTimeStamp < endTimeStamp] whileTrue: [
		(calendar timeIntervalExistFrom: currentTimeStamp to: (currentTimeStamp plusSeconds: 60 "1hour")) 
			ifFalse: [minutesCount := minutesCount + 1]. 

		currentTimeStamp := currentTimeStamp plusSeconds: 60.
	].

	(currentTimeStamp = endTimeStamp and: [(calendar timeIntervalExistFrom: (currentTimeStamp plusSeconds: 60) to: (currentTimeStamp plusSeconds: 60))])
	ifTrue: [minutesCount := minutesCount + 1]. "border case. because above condition loop {currentTimeStamp < endTimeStamp} "

	^minutesCount! !

!BpmExpectedExecutionTime class methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 03:46'!
new

	^self value: 0 withCalendar: BpmExceptionCalendar new! !

!BpmExpectedExecutionTime class methodsFor: 'other' stamp: 'BrunoBB 02/02/2017 08:54'!
value: value withCalendar: aBpmExceptionCalendar

	^super new initialize
		value: value;
		calendar: aBpmExceptionCalendar;
		yourself! !

!BpmExpectedExecutionTime methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 04:43'!
calculateExecutionTimeFrom: aTimeValue
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <today>.
	It use it's calendar to whether or not compute a particular time"

	self subclassResponsibility! !

!BpmExpectedExecutionTime methodsFor: 'other' stamp: 'BrunoBB 02/03/2017 04:06'!
calculateExecutionTimeFrom: startTimeValue to: endTimeValue
	"The receiver calculate (count) the execution time from start time <startTimeValue> to end time <endTimeValue>.
	It use it's calendar to whether or not compute a particular time"

	self subclassResponsibility! !

!BpmExpectedExecutionTime methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2017 08:53'!
calendar
	^calendar! !

!BpmExpectedExecutionTime methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2017 08:53'!
calendar: newValue
	calendar := newValue! !

!BpmExpectedExecutionTime methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2017 03:31'!
value
	^value! !

!BpmExpectedExecutionTime methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2017 03:31'!
value: newValue
	value := newValue! !

!BpmObject class methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:37'!
new

	^super new initialize! !

!BpmObject methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:18'!
getProcessDefinitionCache

	^BpmProcessDefinition cache! !

!BpmObject methodsFor: 'exceptions' stamp: 'BrunoBB 12/04/2015 10:36'!
throwExceptionTaskAssignmentNotFound

	^NoSuchTaskAssignmentException signal: 'The BpmTaskAssignment was not found in the tasks collection'! !

!BpmObject methodsFor: 'exceptions' stamp: 'BrunoBB 12/05/2015 13:57'!
throwNoProcessMatrixExceptionFor: processName

	^NoProcessMatrixException signal: 'No Matrix has been created for process named [', processName, ']'! !

BpmObject subclass: #BpmParticipantDefinition
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParticipantDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
name
	^name! !

!BpmParticipantDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
name: newValue
	name := newValue! !

!BpmParticipantDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 16:32'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',name, ']'.! !

BpmParticipantDefinition subclass: #BpmResourceParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmParticipantDefinition subclass: #BpmRoleParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmProcessDefinition
	instanceVariableNames: 'id processName sheetName executionPath roles processInstances application version subProcesses formFieldInstances participants xmlString'
	classVariableNames: 'AnonymousFormMapping Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessDefinition commentStamp: '' prior: 0!
id 								- id of the process definition
processName 				- name of the process definition
sheetName					- name of the sheet as is in Bizagi modeler
executionPath 			- the execution path of the receiver
roles 							- unused
processInstances 		- all instances of the receiver (BpmProcessInstance)
application	                - application where the process definition is defined (where the definiton belong)
version 						- version of the definition
subProcesses 				- defined sub process of the receiver
formFieldInstances 		- a dictionary of dictionaries to store in one collection all instances of particular field (one collection for each field name)
participants					- additional roles of the receiver
xmlString						- XPDL string of the receiver!

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 10:48'!
anonymousFormMapping

	AnonymousFormMapping ifNil: [AnonymousFormMapping := Dictionary new].

	^AnonymousFormMapping! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/31/2015 09:23'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 06/03/2016 15:36'!
cacheAt: aString ifAbsent: aBlock

	^self cache at: aString ifAbsent: aBlock! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 01/14/2017 10:01'!
getAllArtifactInstances
	| all |

	all := Set new.
	self getAllProcessInstances do: [:eachInstance | 
		all addAll: eachInstance getAllArtifacts. 
	].

	^all! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:39'!
getAllProcessesNamed: aString in: appName
	"Answer a collection with all versions of process named <aString> in the Application named <appName>"

	^((self cache at: appName ifAbsent: [^#()])
			at: aString ifAbsent: [^#()])! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 01/14/2017 10:15'!
getAllProcessInstances
	| all |

	all := Set new.
	self cache do: [:eachDictionary | 
		eachDictionary do: [:definitionCollection | definitionCollection do: [:eachDef | all addAll: eachDef processInstances asArray]]. 
	].

	^all! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 01/13/2017 06:02'!
getAllProcessNamesIn: appName

	^(self cacheAt: appName ifAbsent: [^#()]) keys asSortedCollection! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:57'!
getAllVersionsIn: appName
	"Answer a collection with all processes and all processes versions in Application named <appName>"
	| all |

	all := OrderedCollection new.
	(self cache at: appName ifAbsent: [^all]) do: [:procVersions | all addAll: procVersions].

	^all! !

!BpmProcessDefinition class methodsFor: 'distribution' stamp: 'BrunoBB 10/31/2016 09:20'!
getApplicationAndProcessDefinitionDistribution
	| distribution |

	distribution := OrderPreservingDictionary new.

	self cache keysAndValuesDo: [:appName :procDefDictionary | 
		distribution at: appName put: procDefDictionary size.
	].

	^distribution! !

!BpmProcessDefinition class methodsFor: 'distribution' stamp: 'BrunoBB 10/31/2016 11:11'!
getApplicationAndProcessInstanceDistribution
	| distribution |

	distribution := OrderPreservingDictionary new.

	self cache keysAndValuesDo: [:appName :procDefDictionary | | sum |
		sum := 0.
		procDefDictionary do: [:procDefCollection |
			procDefCollection do: [:each | sum := sum + each processInstances size].
			distribution at: appName put: sum] 
	].

	^distribution! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 07/04/2016 12:21'!
getAssignmentsIn: appName processName: processNamed formName: formNamed fieldName: fieldNamed initialValue: intialValue endValue: endValue
	"The receiver answer a collection of <OrbeonProcessAssignment> in application named <appName>  for process type <processNamed> where the field named <fieldNamed> is equal to <fieldValue>"
	| procDefinition assignments |

	procDefinition := self getAllProcessesNamed: processNamed in: appName.
	procDefinition ifEmpty: [^#()].

	assignments := OrderedCollection new.
	"procDefinition := procDefinition last.
	^procDefinition getFieldsNamed: fieldNamed in: formNamed initialValue: intialValue endValue: endValue"

	procDefinition do: [:eachProcDef | 
		assignments addAll: (eachProcDef getFieldsNamed: fieldNamed in: formNamed initialValue: intialValue endValue: endValue)].

	^assignments! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 07/04/2016 12:22'!
getAssignmentsIn: appName processName: processNamed formName: formNamed fieldName: fieldNamed withValue: fieldValue
	"The receiver answer a collection of <OrbeonProcessAssignment> in application named <appName>  for process type <processNamed> where the field named <fieldNamed> is equal to <fieldValue>"
	| procDefinition assignments |

	procDefinition := self getAllProcessesNamed: processNamed in: appName.
	procDefinition ifEmpty: [^#()].

	assignments := OrderedCollection new.
	"procDefinition := procDefinition last.
	^procDefinition getFieldsNamed: fieldNamed  in: formNamed withValue: fieldValue"

	procDefinition do: [:eachProcDef | 
		assignments addAll: (eachProcDef getFieldsNamed: fieldNamed  in: formNamed withValue: fieldValue)].

	^assignments! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/31/2016 16:10'!
getBpmProcessDefinitionForForm: formName in: appName
	"The receiver answer a <BpmProcessDefinition> associated with the Form <formName> in Application <appName>. If none is associated raise an Exception.
	This process can have an anonymous starter/user (nil)"

	^self anonymousFormMapping 
		at: (appName, '.', formName)
		ifAbsent: [^FormToProcessDefinitionMappingException signal: 'There is NO BpmProcessDefinition mapped to form [', formName, '] in Application [', appName, ']']! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 01/13/2017 07:18'!
getLatestProcessDefinitionNamed: aString in: appName
	"Answer <aBpmProcessDefinition> for process named <aString> in the Application named <appName>"

	^((self cache at: appName ifAbsent: [^nil])
			at: aString ifAbsent: [^nil]) last! !

!BpmProcessDefinition class methodsFor: 'distribution' stamp: 'BrunoBB 11/01/2016 07:56'!
getProcessInstanceDistributionFor: appName
	| applicationDictionary distribution |

	distribution := OrderPreservingDictionary new.
	applicationDictionary := self cacheAt: appName ifAbsent: [^Dictionary new].

	applicationDictionary keysAndValuesDo: [:procName :versionCollection | | sum |
		sum := 0.
		versionCollection do: [:procDef | sum := sum + procDef processInstances size].
		distribution at: procName put: sum.
	]. 

	^distribution! !

!BpmProcessDefinition class methodsFor: 'distribution' stamp: 'BrunoBB 11/02/2016 08:32'!
getProcessInstanceDistributionFor: procName in: appName
	| distribution |

	distribution := OrderPreservingDictionary new.

	(self getAllProcessesNamed: procName in: appName) do: [:eachProcDef | 
		distribution at: eachProcDef version printString put: eachProcDef processInstances size]. 

	^distribution! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 06/03/2016 15:25'!
getProcessInstanceWithId: id
	"Answer <aBpmProcessDefinition> with process id <id>"

	^self getProcessInstanceWithId: id onApplications: self cache! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 06/03/2016 15:31'!
getProcessInstanceWithId: id onApplications: partialDictionaryCache
	"Answer <aBpmProcessDefinition> with process id <id>"

	partialDictionaryCache do: [:eachDefinitionDictionary | 
		eachDefinitionDictionary do: [:eachDefinitionCollection | 
			eachDefinitionCollection do: [:eachDefinition | 
				(eachDefinition getProcessInstanceWith: id ifAbsent: [nil]) ifNotNil: [:object | ^object]]
		].
	].

	^nil! !

!BpmProcessDefinition class methodsFor: 'distribution' stamp: 'BrunoBB 11/07/2016 07:10'!
getVersionsAverageTimeFor: processNamed in: appName
	| versions distribution |

	distribution := OrderPreservingDictionary new.

	versions := self getAllProcessesNamed: processNamed in: appName.

	versions do: [:procDef | | avgTime |
		avgTime := procDef getAverageTime.
		avgTime isZero
		ifFalse: [distribution at: procDef version printString put: avgTime]
		ifTrue: [distribution at: procDef version printString put: 0.001] 
	]. 

	^distribution! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 02/29/2016 09:25'!
hasAnyProcessApplicationNamed: aString
	"Answer whether or not the Application named <aString> has any BpmProcessDefinition"

	^(self cache includesKey: aString) and: [(self cache at: aString) notEmpty]! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 10:45'!
initializeAnonymousFormMapping

	AnonymousFormMapping := Dictionary new! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/31/2015 09:23'!
initializeCache

	Cache := Dictionary new! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/27/2015 15:28'!
newNamed: aString

	^super new initialize
		processName: aString;
		yourself! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 16:12'!
registerAnonymousMappingForm: formName in: appName for: aBpmProcessDefinition

	^self anonymousFormMapping at: (appName, '.', formName) put: aBpmProcessDefinition! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 06/20/2016 14:37'!
removeAllDefinitions
	"Remove all defined <BpmProcessDefinition> and unassign roles from process's artifacts"

	self cache do: [:eachDictionary | 
		eachDictionary do: [:procCollection | 
			procCollection do: [:eachProc | 
				eachProc getAllArtifacts do: [:eachArt | eachArt ungrantAllRoles]. "remove tasks from roles"
			].
		].
	].

	^self initializeCache! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 06/20/2016 14:36'!
removeAllFormFieldInstances
	"Remove ALL instances of <AppFieldValue> from each <BpmProcessInstance>."

	self cache do: [:eachDictionary | 
		eachDictionary do: [:procCollection | 
			procCollection do: [:eachProc | 
				eachProc formFieldInstances: Dictionary new. "remove all form field instances"
			].
		].
	].! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/04/2016 05:27'!
reportCreationDayFor: processName in: appName from: startDate to: endDate satisfying: satisfyingBlock

	^self reportCreationDayFor: processName in: appName version: nil from: startDate to: endDate satisfying: satisfyingBlock! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/04/2016 05:46'!
reportCreationDayFor: processName in: appName version: version from: startDate to: endDate satisfying: satisfyingBlock
	| distribution secondsToRun definitionCollection |

	secondsToRun := 0.
	distribution := OrderPreservingDictionary new.

	definitionCollection := version isNil
			ifTrue: [self getAllProcessesNamed: processName in: appName] 
			ifFalse: [(self getAllProcessesNamed: processName in: appName) select: [:each | each version = version]].

	definitionCollection do: [:procDef | 
		secondsToRun := secondsToRun + (Time secondsElapsedTime: [procDef addTo: distribution instancesDayDistributionFrom: startDate to: endDate satisfying: satisfyingBlock]).
	].

	^(BpmProcessDistributionReport processName: processName applicationName: appName distribution: distribution)
		startDate: startDate;
		endDate: endDate;
		conditionStringBlock: satisfyingBlock blockSource;
		distributionMethod: #createdTime;
		sumSecondsToConstruct: secondsToRun;
		yourself! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/07/2016 03:34'!
reportProcessAverageTimeDistributionFor: procName in: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getVersionsAverageTimeFor: procName in: appName].
 
	^(BpmProcessDistributionReport processName: procName applicationName: appName distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/01/2016 04:35'!
reportProcessDefinitionsQuantityDistribution
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getApplicationAndProcessDefinitionDistribution].
 
	^(AppGlobalDistributionReport distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/01/2016 04:34'!
reportProcessInstancesQuantityDistribution
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getApplicationAndProcessInstanceDistribution].
 
	^(AppGlobalDistributionReport distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/01/2016 07:59'!
reportProcessInstancesQuantityDistributionFor: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getProcessInstanceDistributionFor: appName].
 
	^(BpmApplicationDistributionReport applicationName: appName distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmProcessDefinition class methodsFor: 'distribution report' stamp: 'BrunoBB 11/02/2016 08:28'!
reportProcessInstancesQuantityDistributionFor: procName in: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getProcessInstanceDistributionFor: procName in: appName].
 
	^(BpmProcessDistributionReport processName: procName applicationName: appName distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 08/06/2016 09:21'!
resetAll

	self removeAllDefinitions.
	self removeAllFormFieldInstances.

	BpmUser cache do: [:each | each resetAll].
	
	BpmProcessInstance resetAll.

	AbstractApplication initializeCache.

	BpmBackofficeRole initializeCache. "create the default role -admin-"
	(BpmBackofficeRole getRoleNamed: 'admin' in: 'admins') grantUser: (BpmUser getExistingOrNewUserNamed: 'admin' password: 'admin').
	BpmFrontOfficeRole initializeCache.

	BpmRunningTasksMatrix initializeCache.
	BpmFinishedTasksMatrix initializeCache.! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 16:08'!
unregisterAnonymousMappingFor: formName in: appName

	^self anonymousFormMapping removeKey: (appName, '.', formName) ifAbsent: []! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:55'!
addAllParticipants: aCollection
	"The receiver add all participants <BpmParticipantDefinition> in the collection <aCollection>"

	^aCollection do: [:bpmParticipant | participants at: bpmParticipant name put: bpmParticipant]! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addEndEvent: aBpmEndEventDefinition
	"The receiver add the event definition <aBpmEndEventDefinition>"

	^executionPath addEndEvent: aBpmEndEventDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addGateway: aBpmGatewayDefinition
	"The receiver add the gateway definition <aBpmGatewayDefinition>"

	^executionPath addGateway: aBpmGatewayDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addIntermediateEvent: aBpmIntermediateEventDefinition
	"The receiver add the intermediate definition <aBpmIntermediateEventDefinition>"

	^executionPath addIntermediateEvent: aBpmIntermediateEventDefinition! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/28/2015 19:59'!
addProcessInstance: aBpmProcessInstance
	"The receiver add the process instance <aBpmProcessInstance> to it's collection"

	^processInstances at: aBpmProcessInstance id put: aBpmProcessInstance! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 06/22/2016 11:46'!
addScript: aBpmScriptTaskDefinition
	"The receiver add the event definition <aBpmScriptTaskDefinition>"

	^executionPath addScript: aBpmScriptTaskDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 05:56'!
addSubProcess: aBpmSubProcessDefinition
	"The receiver add the subprocess <aBpmSubProcessDefinition> to it's sub process collection. Set the receiver as the parent process of the process argument <aBpmSubProcessDefinition>"

	aBpmSubProcessDefinition parentProcess: self.

	^subProcesses at: aBpmSubProcessDefinition processName put: aBpmSubProcessDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addSubProcessTask: aBpmSubProcessTaskDefinition
	"The receiver add the subprocess task definition <aBpmSubProcessTaskDefinition>"

	^executionPath addSubProcessTask: aBpmSubProcessTaskDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addTask: aBpmTaskDefinition
	"The receiver add the task definition <aBpmTaskDefinition>"

	^executionPath addTask: aBpmTaskDefinition! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 05/02/2016 13:09'!
addTo: formNamed fieldValue: anAppFieldValue
	"The receiver add to Orbeon form named <formNamed> the field value <anAppFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) "we get the dictionary for the form named <formNamed>"
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [formFieldInstances at: formNamed put: Dictionary new].

	fieldCollection := (fieldsDictionary includesKey: anAppFieldValue getKeyName) "we get the Rc collection for the proper field"
		ifTrue: [fieldsDictionary at: anAppFieldValue getKeyName]
		ifFalse: [fieldsDictionary at: anAppFieldValue getKeyName put: RcIdentityBag new].

	^fieldCollection add: anAppFieldValue! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/04/2016 05:33'!
addTo: distributionDictionary instancesDayDistributionFrom: startDate to: endDate satisfying: processConditionBlock

	^self addTo: distributionDictionary instancesDayDistributionQuantityUsing: #createdTime from: startDate to: endDate satisfying: processConditionBlock! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 09:44'!
addTo: distributionDictionary instancesDayDistributionQuantityUsing: sortSelector from: startDate to: endDate satisfying: processConditionBlock

	(processInstances select: [:each | | value |
		value := each perform: sortSelector.
		startDate <= value  and: [(value <= endDate) and: [processConditionBlock asBpmBlock value: each]]])
			do: [:each | | key value |
				value := each perform: sortSelector.
				key := value date asDays - startDate asDays.
				(distributionDictionary includesKey: key) 
					ifFalse: [distributionDictionary at: key put: 1] 
					ifTrue: [distributionDictionary at: key put: ((distributionDictionary at: (key)) + 1)]].

	^distributionDictionary! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
addToAnonymousStart

	^self class anonymousFormMapping at: self getAnonymousFormName put: self! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:44'!
addToCache
	"Add the receiver to the global cache for this class"
	| processesDictionary processDefinitions |

	(processName isNil or:[processName isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	application ifNil: [^NoApplicationException signal: 'ProcessDefinition MUST have anOrbeonApplication'].

	processesDictionary := (self class cache includesKey: application applicationName) "get the dictionary of processes"
			ifTrue: [self class cache at: application applicationName]
			ifFalse: [self class cache at: application applicationName put: Dictionary new].

	processDefinitions := (processesDictionary includesKey: processName) "get the collection of versions for definition named <processName>"
			ifTrue: [processesDictionary at: processName] 
			ifFalse: [processesDictionary at: processName put: OrderedCollection new].

	processDefinitions isEmpty 
	ifFalse: [version := processDefinitions last version + 1]
	ifTrue: [version := 1].

	processDefinitions add: self.! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addTransition: aBpmTransitionDefinition
	"The receiver add the transition definition <aBpmTransitionDefinition>"

	^executionPath addTransition: aBpmTransitionDefinition! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2015 12:21'!
application
	^application! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2015 12:21'!
application: newValue
	application := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:45'!
applicationName

	^application applicationName! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:30'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	^false! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/22/2015 15:50'!
canCreateProcessInstance: aBpmUser
	"Answer whether or not the user <aBpmUser> can create a process instance of the receiver"

	^executionPath canCreateProcess: aBpmUser! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 08/30/2016 13:15'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"
	| definitionsCollection |

	definitionsCollection := self class getAllProcessesNamed: processName in: self applicationName.
	^formFieldInstances isEmpty 
		and: [(definitionsCollection size = version) or:[definitionsCollection size = 0]] 
				"this is to preserve the version number chain unbroken - (only the latest version can be removed)"! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:51'!
canModifyPathDefinition

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/14/2016 14:28'!
clone
	"The receiver is cloned with a new version number"
	| xpdlReader processGenerator |

	xpdlReader := XPDLReader2 for: processName withString: xmlString.

	subProcesses do: [:each | xpdlReader addXPDLDocument:  (XMLDOMParser parse: each xmlString) namedAs: each processName].

	xpdlReader connectProcesses.

	processGenerator :=  BpmProcessGenerator on: xpdlReader xpdlPackages.

	processGenerator mapProcess: processName toApplication: application.

	subProcesses do: [:each | processGenerator mapProcess: each processName toApplication: each application].

	processGenerator generateAllProcess.

	"processGenerator processes do: [:each | each addToCache]."

	^processGenerator processes! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 03/30/2016 16:48'!
createAndStartProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"

	^(self createProcessInstance: aBpmUser)
		triggerStartEventWith: aBpmUser;
		yourself! !

!BpmProcessDefinition methodsFor: 'indexes' stamp: 'BrunoBB 05/02/2016 13:39'!
createFieldIndexInForm: formName forFieldNamed: fieldName type: aStClass
	"The receiver create anIndex in the form definition named <formName> for the field named <fieldName> with index type <aStClass>"
	| formsDictionary indexedCollection |

	(formFieldInstances includesKey: formName) ifFalse: [^NoFormNameException signal: 'There is no form named [', formName, '].'].

	formsDictionary := formFieldInstances at: formName.

	(formsDictionary includesKey: fieldName) ifFalse: [^NoFieldNameException signal: 'There is no field named [', fieldName, '].'].

	indexedCollection := formsDictionary at: fieldName.

	(indexedCollection size >= 2000) "see GemStone/S manual on indexes"
	ifFalse: [^CollectionWithout2000ElementsException signal: 'The collection should have at least 2000 elements to create an index on it.'].

	GsIndexSpec new
		equalityIndex: 'each.value' lastElementClass: aStClass;
		createIndexesOn: indexedCollection.! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 03/26/2016 14:33'!
createProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"
	| newProcess |

	(self canCreateProcessInstance: aBpmUser) ifFalse: [^self throwNoCreationPermissionExceptionFor: aBpmUser username].

	newProcess := self getProcessInstanceClass definition: self user: aBpmUser.

	self addProcessInstance: newProcess. "add the new process instance dictionary"

	^newProcess! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:20'!
createZipFileWithName: pathFile
	| file archive |

	archive := ZipArchive new.

	file := GsFile open: pathFile mode: 'wb' onClient: false.

	self storeOnZip: archive withFile: file.

	file close.! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath
	^executionPath! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath: newValue
	executionPath := newValue! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/05/2016 13:15'!
fieldInstancesOf: fieldName in: formName
	"The receiver answer the set collection that contains the FormFieldValue's of the field named <fieldName>"

	^(formFieldInstances at: formName ifAbsent: [^IdentitySet new]) at: fieldName ifAbsent: [IdentitySet new]! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances
	^formFieldInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances: newValue
	formFieldInstances := newValue! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 09:59'!
getAllArtifacts
	"The receiver answer a collection with all artifacts <aBpmArtifactDefinition>"

	^executionPath getAllArtifacts! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 07:56'!
getAllFieldNames

	^executionPath getAllFieldNames asSet asSortedCollection! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:49'!
getAllRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"

	^executionPath getAllRoles! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 06/18/2016 13:47'!
getAnonymousFormName
	"Answer the name of the anonymous form"

	^[executionPath getAnonymousFormName] on: Exception do: [:ex | ^'N/A']! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/08/2016 14:45'!
getApplicationName

	^application applicationName! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 13:00'!
getApplicationNameForCombo

	^application getApplicationNameForCombo! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/07/2016 07:09'!
getAverageTime
	| totalTime |

	totalTime := processInstances inject: 0 into: [:sum :each | sum + each getTotalTime asSeconds].

	^(totalTime / processInstances size) asScaledDecimal: 2! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/12/2016 07:31'!
getAverageTimeForAllTasks
	| distribution |

	distribution := OrderPreservingDictionary new.

	self getOrderedTasks do: [:taskDef | 
		distribution 
			at: taskDef name 
			put: (self getAverageTimeForTaskNamed: taskDef name) asSeconds. 
	]. 

	^distribution! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/12/2016 07:32'!
getAverageTimeForAllTasksFrom: startDate to: endDate satisfying: conditionBlock
	| distribution |

	distribution := OrderPreservingDictionary new.

	self getOrderedTasks do: [:taskDef | 
			distribution 
				at: taskDef name 
				put: (self getAverageTimeForTaskNamed: taskDef name from: startDate to: endDate satisfying: conditionBlock) asSeconds. 
	]. 

	^distribution! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/07/2016 14:31'!
getAverageTimeForTaskNamed: aString
	| totalTime taskCount |

	taskCount := 0.
	totalTime := processInstances inject: 0 into: [:sum :each | 
							((self hasTaskNamed: aString) or: [self hasSubProcessNamed: aString])
							ifTrue: [taskCount := taskCount + 1.
										sum + (each getTotalTimeOfTaskNamed: aString) asSeconds] 
							ifFalse: [sum] 
					].

	taskCount isZero ifTrue: [^Time fromSeconds: 0].
 
	^Time fromSeconds: ((totalTime / taskCount) asScaledDecimal: 2)! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 09:45'!
getAverageTimeForTaskNamed: aString from: startDate to: endDate satisfying: conditionBlock
	| filteredCollection totalTime taskCount |

	taskCount := 0.
	filteredCollection := processInstances select: [:procInst | ((startDate <= procInst createdTime) and: [procInst createdTime <= endDate]) and: [conditionBlock asBpmBlock value: procInst]].

	totalTime := filteredCollection inject: 0 into: [:sum :each | 
							((self hasTaskNamed: aString) or: [self hasSubProcessNamed: aString])
							ifTrue: [taskCount := taskCount + 1.
										sum + (each getTotalTimeOfTaskNamed: aString) asSeconds] 
							ifFalse: [sum] 
					].

	taskCount isZero ifTrue: [^Time fromSeconds: 0].
 
	^Time fromSeconds: ((totalTime / taskCount) asScaledDecimal: 2)! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:49'!
getEndEventNamed: aString ifNone: aBlock
	"The receiver answer the end event <BpmEndEventDefinition> named <aString> if such event does not exist evaluate <aBlock> "

	^executionPath getEndEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 12:42'!
getFieldNamesOfTask: taskName
	"Answer a collection with all field names for task named <taskName>.
	Includes field of all form definition versions and types of the fields.
	For example: 'number[s], number[n]' "

	^(formFieldInstances at: taskName ifAbsent: [^#()]) keys asSortedCollection! !

!BpmProcessDefinition methodsFor: 'search' stamp: 'BrunoBB 04/23/2016 12:55'!
getFieldsNamed: fieldNamed in: formNamed initialValue: intialValue endValue: endValue
	"The receiver answer a collection of <OrbeonProcessAssignment>s with field named <fieldNamed> in form named <formNamed> where the value of the object is greater thatn <intialValue> and less than <endValue>"
	| taskDefinition formDictionary fieldRcUnCollection stType stValue stValue2 |

	"we get the actual definition because the OrbeonForms and SeasideModel use different name convention, see #getObjectName #taskName"
	taskDefinition := self getTaskNamed: formNamed ifNone: [^#()].

	formDictionary := formFieldInstances at: taskDefinition taskName ifAbsent: [^#()].
	fieldRcUnCollection := formDictionary at: fieldNamed ifAbsent: [^#()].

	stType := self getTypeOfFieldNamed: fieldNamed.
	stValue := [stType fromString: intialValue] on: Error do: [:err | ^#()].
	stValue2 := [stType fromString: endValue] on: Error do: [:err | ^#()].

	^((GsQuery fromString: ('(each.value >= intialValue) & (each.value <= endValue)') on: fieldRcUnCollection) 
		bind: 'intialValue' to: stValue; 
		bind: 'endValue' to: stValue2; 
		queryResult) collect: [:each | each getAssignment]! !

!BpmProcessDefinition methodsFor: 'search' stamp: 'BrunoBB 04/23/2016 12:55'!
getFieldsNamed: fieldNamed in: formNamed withValue: fieldValue
	"The receiver answer a collection of <OrbeonProcessAssignment>s with field named <fieldNamed> with value <fieldValue> in form <formNamed>"
	| taskDefinition formDictionary fieldRcUnCollection stType stValue |

	"we get the actual definition because the OrbeonForms and SeasideModel use different name convention, see #getObjectName #taskName"
	taskDefinition := self getTaskNamed: formNamed ifNone: [^#()].

	formDictionary := formFieldInstances at: taskDefinition taskName ifAbsent: [^#()].
	fieldRcUnCollection := formDictionary at: fieldNamed ifAbsent: [^#()].

	stType := self getTypeOfFieldNamed: fieldNamed.
	stValue := [stType fromString: fieldValue] on: Error do: [:err | ^#()].

	^((GsQuery fromString: ('each.value = stValue') on: fieldRcUnCollection) 
		bind: 'stValue' to: stValue; 
		queryResult) collect: [:each | each getAssignment]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/23/2016 14:13'!
getFormDefinitionNamed: formName ifNone: aBlock
	"The receiver answer a form definition <OrbeonFormDefinition> named <endFormName>.
	If the form does not exist evaluate the zero argument block <aBlock>"
	| taskDefinition |

	taskDefinition := self getTasks detect: [:each | each name = formName] ifNone: [^aBlock value].

	^taskDefinition getObjectModel! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:50'!
getGatewayNamed: aString ifNone: aBlock
	"The receiver answer the gateway <BpmGatewayDefinition> named <aString> if such gateway does not exist evaluate <aBlock> "

	^executionPath getGatewayNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/04/2016 05:13'!
getInstancesCreationDayDistributionQuantityFrom: startDate to: endDate satisfying: processConditionBlock

	^self getInstancesDayDistributionQuantityUsing: #createdTime from: startDate to: endDate satisfying: processConditionBlock! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/04/2016 05:23'!
getInstancesDayDistributionQuantityUsing: sortSelector from: startDate to: endDate satisfying: processConditionBlock

	^self addTo: OrderPreservingDictionary new instancesDayDistributionQuantityUsing: sortSelector from: startDate to: endDate satisfying: processConditionBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:50'!
getIntermediateEventNamed: aString ifNone: aBlock
	"The receiver answer the intermediate event <BpmIntermediateEventDefinition> named <aString> if such event does not exist evaluate <aBlock> "

	^executionPath getIntermediateEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfEndEvents

	^executionPath getNumberOfEndEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfGateways

	^executionPath getNumberOfGateways! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfIntermediateEvents

	^executionPath getNumberOfIntermediateEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 06/24/2016 09:36'!
getNumberOfScripts

	^executionPath getNumberOfScripts! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfSubProcessTasks

	^executionPath getNumberOfSubProcessTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTasks

	^executionPath getNumberOfTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTransitions

	^executionPath getNumberOfTransitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/04/2016 10:44'!
getOrbeonTaskNames
	"The receiver answer a collection with all names of it's tasks <aBpmTaskDefinition>"

	^self getOrbeonTasks collect: [:each | each name]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/04/2016 10:43'!
getOrbeonTasks
	""

	^executionPath getOrbeonTasks! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:09'!
getOrderedTasks

	^executionPath getOrderedTasks! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 17:46'!
getOrderedTasksNames

	^executionPath getOrderedTasks collect: [:each | each name]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:48'!
getParentProcessName

	^self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 09:42'!
getParentSubProcessTaskDefinition
	"Answer a <aBpmSubProcessTaskDefinition> that created the receiver"

	self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 11:00'!
getParentTopSubProcessTaskDefinition
	"Answer the Top <BpmSubProcessTaskDefinition> that initiated the creation of the receiver"

	self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'running' stamp: 'BrunoBB 04/10/2016 18:49'!
getProcessesTreeAsCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	^self getProcessTree: OrderedCollection new! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 17:23'!
getProcessInstanceWith: instanceId ifAbsent: aBlock

	^processInstances at: instanceId ifAbsent: aBlock! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:32'!
getProcessMapStream

	^self hasSubProcesses
		ifTrue: [self getZipProcessMapStream] "generate a ZIP with all subprocesses"
		ifFalse: [self getSingleProcessMapStream]. "generate a XPDL"! !

!BpmProcessDefinition methodsFor: 'running' stamp: 'BrunoBB 04/10/2016 18:49'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/05/2016 12:58'!
getQuantityDistributionForFieldNamed: fieldName in: formName
	"Answer a Dictionary where the key is a value of field <fieldName> and value is the percentage of value in the whole"

	^self getValueDistributionForFieldCollection: (self fieldInstancesOf: fieldName in: formName)! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 06/22/2016 11:49'!
getScriptNamed: aString ifNone: aBlock
	"The receiver answer the task <BpmScriptTaskDefinition> named <aString> if such task does not exist evaluate <aBlock> "

	^executionPath getScriptNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:31'!
getSingleProcessMapStream
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>', String lf, xmlString.

	^stream! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:51'!
getSubProcessDefinitions
	"Answer a collection with all receiver's subprocesses <BpmProcessDefinition>"

	^self getSubProcessTasks collect: [:each | each subProcessDefinition]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:22'!
getSubProcessNamed: aString ifAbsent: aBlock

	^subProcesses at: aString ifAbsent: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:51'!
getSubProcessTaskNamed: aString ifNone: aBlock
	"The receiver answer the subprocess <BpmProcessDefinition> named <aString> if such subprocess does not exist evaluate <aBlock> "

	^executionPath getSubProcessTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:52'!
getSubProcessTasks
	"Answer a collection with all receiver's subprocesses tasks <BpmSubProcessTaskDefinition>"

	^executionPath subProcessTasks! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:53'!
getTaskNamed: aString ifNone: aBlock
	"The receiver answer the task <BpmTaskDefinition> named <aString> if such task does not exist evaluate <aBlock> "

	^executionPath getTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/18/2016 12:15'!
getTaskNames
	"The receiver answer a collection with all names of it's tasks <aBpmTaskDefinition>"

	^self getTasks collect: [:each | each name]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 06:36'!
getTasks
	"The receiver answer a collection with all of it's tasks <aBpmTaskDefinition>"

	^executionPath tasks! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:20'!
getTopProcess
	^self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:53'!
getTransitionNamed: aString ifNone: aBlock
	"The receiver answer the transition <BpmTransitionDefinition> named <aString> if such transition does not exist evaluate <aBlock> "

	^executionPath getTransitionNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:52'!
getTransitions

	^executionPath transitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/19/2016 13:38'!
getTypeOf: fieldNamed in: formName ifNone: aBlock
	"The receiver answer the type of the field named <fieldNamed> in the form definition named <formName>.
	If the form is not found then evaluate the zero argument block <aBlock>"
	| taskDefinition |

	taskDefinition := self getTaskNamed: formName ifNone: [^aBlock value].

	^taskDefinition getObjectModel stTypeOf: fieldNamed! !

!BpmProcessDefinition methodsFor: 'search' stamp: 'BrunoBB 04/23/2016 12:55'!
getTypeOfFieldNamed: nameWithType
	"The receiver answer a Smalltalk class with the type of the field named <nameWithType>.
	The type is already embedded in the string <nameWithType> "

	^AppFieldValue getTypeOfFieldNamed: nameWithType! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/05/2016 12:55'!
getValueDistributionForFieldCollection: fieldInstancesCollection
	"Answer a Dictionary where the key is a value of field <fieldName> and value is a quantity in the whole collection <fieldInstancesCollection>"
	| distribution |
 
	distribution := OrderPreservingDictionary new.

	fieldInstancesCollection do: [:fieldInst |  | fieldValue count |
		fieldValue := (fieldInst value class = String) ifTrue: [fieldInst value] ifFalse: [fieldInst value printString] . 
		(distribution includesKey: fieldValue) ifFalse: [distribution at: fieldValue put: 0].
		count := (distribution at: fieldValue) + 1.
		distribution at: fieldValue put: count.
	].

	^distribution! !

!BpmProcessDefinition methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 09:49'!
getValueDistributionForFieldName: fieldName secondaryField: secondaryField in: formName satisfying: formConditionBlock
     "The receiver answer anArray with two Dictionaries <OrderPreservingDictionary> with receiver's field instances value distribution.
     The first dictionary is the main distribution for the field named <fieldName>.
     The second dictionary is the second distribution for the field named <secondaryField>."
     | distribution secondaryDistribution blockFilteredCollection |

	blockFilteredCollection := (self fieldInstancesOf: fieldName in: formName) select: [:fieldInst | formConditionBlock asBpmBlock value: fieldInst parentObject].

   distribution := OrderPreservingDictionary new.
   secondaryDistribution := OrderPreservingDictionary new.

   blockFilteredCollection do: [:fieldInst |  | fieldValue count secondaryValue secondaryCount subValueDictionary |
		fieldValue := (fieldInst value class = String) ifTrue:[fieldInst value] ifFalse: [fieldInst value printString].
        (distribution includesKey: fieldValue) ifFalse: [distribution at: fieldValue put: 0].
        count := (distribution at: fieldValue) + 1.
        distribution at: fieldValue put: count. "main distribution"

        secondaryValue := fieldInst parentObject fieldValueAt: secondaryField.

        (secondaryDistribution includesKey: fieldValue) ifFalse: [secondaryDistribution at: fieldValue put: Dictionary new].
		subValueDictionary := secondaryDistribution at: fieldValue.
        secondaryCount := (subValueDictionary at: secondaryValue ifAbsent: [0]) + 1.
		subValueDictionary at: secondaryValue put: secondaryCount.
    ].

     ^Array with: distribution with: secondaryDistribution! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:32'!
getZipProcessMapStream
	| fileStream fileName |

	fileName := '/tmp/', processName, Lag1MwcRandom new integer printString, '.zip'.

	self createZipFileWithName: fileName.

	fileStream := FileStream read: fileName.

	^fileStream! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:51'!
hasFinishedProcesses

	^processInstances notEmpty! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 15:06'!
hasGatewayConditionIncludingFieldNamed: fieldName
	"Answer whether or not the receiver has a <BpmGatewayDefinition> with condition that includes a field named <fieldName>"

	^executionPath hasGatewayConditionIncludingFieldNamed: fieldName! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 01/23/2016 07:26'!
hasOrbeonFormNamed: aString
	"The receiver answer whether or not it hold a form <OrbeonFormDefinition> named <aString>"

	^executionPath hasOrbeonFormNamed: aString! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 04/15/2016 10:13'!
hasSubProcesses

	^subProcesses notEmpty! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 14:32'!
hasSubProcessNamed: aString

	^(self getSubProcessNamed: aString ifAbsent: [nil]) notNil! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/21/2015 09:45'!
hasTaskNamed: aString

	^executionPath hasTaskNamed: aString! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
id
	^id! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
id: newValue
	id := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 14:36'!
initialize

	super initialize.

	id := Lag1MwcRandom new integer.
	executionPath := BpmProcessPathDefinition definition: self.
	roles := Dictionary new.
	participants := Dictionary new.
	version := 1.
	subProcesses := Dictionary new.
	processInstances := RcKeyValueDictionary new.
	formFieldInstances := Dictionary new.! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
isAnonymousStartEnabled

	^self class anonymousFormMapping includesKey: self getAnonymousFormName! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
isSubProcess

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:17'!
isTopProcess

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
parentProcess

	^self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
participants
	^participants! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
participants: newValue
	participants := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:41'!
printArtifacts

	^executionPath printArtifacts! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:52'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', processName, ' v.', version printString, ']'! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/12/2015 13:03'!
printParentName

	^self parentProcess ifNil: ['-'] ifNotNil: [:value | value processName]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions

	^executionPath printTransitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 06:39'!
processId

	^id! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances
	^processInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances: newValue
	processInstances := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
processName
	^processName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
processName: newValue
	processName := newValue! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 04/20/2016 17:03'!
removeFrom: formNamed fieldValue: anAppFieldValue
	"The receiver remove from Orbeon form named <formNamed> the field value <anAppFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) 
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [^nil].

	fieldCollection := (fieldsDictionary includesKey: anAppFieldValue getKeyName)
		ifTrue: [fieldsDictionary at: anAppFieldValue getKeyName]
		ifFalse: [^nil].

	^fieldCollection remove: anAppFieldValue ifAbsent: [nil]! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
removeFromAnonymousStart

	^self class anonymousFormMapping 
		removeKey: self getAnonymousFormName 
		ifAbsent: [FormToProcessDefinitionMappingException signal: 'This process is NOT mapped to a Form for an anonymous start']! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:59'!
removeFromCache
	"Remove the receiver from the global cache of this class"
	| processesDictionary processDefinitions |

	(processName isNil or:[processName isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	application ifNil: [^NoApplicationException signal: 'ProcessDefinition MUST have an Application'].

	processesDictionary := (self class cache includesKey: application applicationName) "get the dictionary of processes"
			ifTrue: [self class cache at: application applicationName]
			ifFalse: [^NoApplicationException signal: 'No such Process Definition'].

	processDefinitions := (processesDictionary includesKey: processName) "get the collection of versions for definition named <processName>"
			ifTrue: [processesDictionary at: processName] 
			ifFalse: [^AppObjectNotInCacheException signal: 'No such Process Definition'].

	processDefinitions isEmpty ifTrue: [^AppObjectNotInCacheException signal: 'No such Process Definition'].

	(processDefinitions last == self) ifFalse: [^BrokenProcessVersionException signal: 'Remove latest versions first'].

	processDefinitions remove: self ifAbsent: [^AppObjectNotInCacheException signal: 'No such Process Definition'].

	processDefinitions isEmpty 
	ifTrue: [(self class cache at: application applicationName) removeKey: processName ifAbsent: []].! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/28/2015 19:59'!
removeProcessInstance: aBpmProcessInstance
	"The receiver remove the process instance <aBpmProcessInstance> from it's collection"

	^processInstances removeKey: aBpmProcessInstance id! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:30'!
reportAverageTimeDistributionForAllTasksFor: aBpmUser
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForAllTasks].
 
	^(BpmProcessDistributionReport processName: processName applicationName: self getApplicationName distribution: distribution)
		name: ('Average Time for All Tasks' translateFor: aBpmUser);
		sumSecondsToConstruct: secondsToRun;
		version: version;
		yourself.! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:30'!
reportAverageTimeDistributionForAllTasksFor: aBpmUser from: startDate to: endDate satisfying: conditionBlock
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForAllTasksFrom: startDate to: endDate satisfying: conditionBlock].
 
	^(BpmProcessDistributionReport processName: processName applicationName: self getApplicationName distribution: distribution)
		name: ('Average Time for All Tasks' translateFor: aBpmUser);
		sumSecondsToConstruct: secondsToRun;
		version: version;
		yourself.! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:30'!
reportAverageTimeDistributionForTaskNamed: taskName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForTaskNamed: taskName].
 
	^(BpmProcessDistributionReport processName: processName applicationName: self getApplicationName distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		version: version;
		yourself.! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/04/2016 05:19'!
reportInstancesCreationDayDistributionFrom: startDate to: endDate satisfying: processConditionBlock

	^self reportInstancesDayDistributionUsing: #createdTime from: startDate to: endDate satisfying: processConditionBlock! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:30'!
reportInstancesDayDistributionUsing: sortSelector from: startDate to: endDate satisfying: formConditionBlock
	| distribution secondsToRun |

	secondsToRun := Time secondsElapsedTime: [distribution := self getInstancesDayDistributionQuantityUsing: sortSelector from: startDate to: endDate satisfying: formConditionBlock].

	^(BpmProcessDistributionReport processName: self processName applicationName: self applicationName distribution: distribution)
		startDate: startDate;
		endDate: endDate;
		conditionStringBlock: formConditionBlock blockSource;
		distributionMethod: sortSelector;
		sumSecondsToConstruct: secondsToRun;
		version: version;
		yourself! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/20/2016 11:07'!
reportTotalValueDistributionFor: fieldName in: formName
	"Answer a Dictionary where the key is a value of field <fieldName> and value is the percentage of value in the whole"
	
	^(self reportValueDistributionForFieldCollection: (self fieldInstancesOf: fieldName in: formName))
		formName: formName;
		yourself! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/20/2016 11:07'!
reportValueDistributionFor: fieldName in: formName from: startDate to: endDate satisfying: formConditionBlock
	"Answer a Dictionary where the key is a value of field <fieldName> and value is the percentage of value in the whole"
	| secondsToRun filteredCollection |

	secondsToRun := Time secondsElapsedTime: [
									filteredCollection := (self fieldInstancesOf: fieldName in: formName) 
											select: [:fieldInst | (startDate <= fieldInst parentObject createdTime) 
																	and: [(fieldInst parentObject createdTime <= endDate)
																and: [formConditionBlock asBpmBlock value: fieldInst parentObject]]
											]
							].

	^(self reportValueDistributionForFieldCollection: filteredCollection)
		startDate: startDate;
		endDate: endDate;
		formName: formName; 
		conditionStringBlock: formConditionBlock blockSource;
		sumSecondsToConstruct: secondsToRun;
		yourself! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:41'!
reportValueDistributionForFieldCollection: fieldInstancesCollection
	"Answer a Dictionary where the key is a value of field <fieldName> and value is the percentage of value in the whole"
	| secondsToRun distribution fieldName |

	fieldName := fieldInstancesCollection ifEmpty: ['no-instances'] ifNotEmpty: [(fieldInstancesCollection at: 1) name].

	secondsToRun := Time secondsElapsedTime: [distribution := self getValueDistributionForFieldCollection: fieldInstancesCollection].
	
	^(BpmFieldDistributionReport processName: processName applicationName: self applicationName distribution: distribution)
			sumSecondsToConstruct: secondsToRun;
			fieldName: fieldName;
			version: version;
			yourself! !

!BpmProcessDefinition methodsFor: 'distribution report' stamp: 'BrunoBB 11/18/2016 03:41'!
reportValueDistributionForFieldName: fieldName secondaryField: secondaryField in: formName satisfying: formConditionBlock
	""
	| secondsToRun distributionArray |

	secondsToRun := Time secondsElapsedTime: [distributionArray := self getValueDistributionForFieldName: fieldName secondaryField: secondaryField in: formName satisfying: formConditionBlock].
	
	^(BpmRecursiveFieldDistributionReport processName: processName applicationName: self applicationName distribution: distributionArray first)
			sumSecondsToConstruct: secondsToRun;
			addSubDistribution: distributionArray second;
			formName: formName;
			fieldName: fieldName;
			secondaryField: secondaryField;
			version: version;
			yourself! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
roles
	^roles! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
roles: newValue
	roles := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName
	^sheetName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName: newValue
	sheetName := newValue! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 10/28/2015 12:37'!
startEvent

	^executionPath startEvent! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 10/27/2015 17:27'!
startEvent: aBpmStartEventDefinition

	^executionPath startEvent: aBpmStartEventDefinition! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:51'!
storeOnZip: aZipArchive withFile: aGsFile
	|  stream member |

	stream := RWBinaryOrTextStream on: String new. 
	member := aZipArchive 
						addString: (self xmlHeader, xmlString) 
						as: (processName, '.xpdl').

	member desiredCompressionMethod: ZipArchive compressionDeflated. 

	aZipArchive writeTo: stream. 
	aGsFile nextPutAll: stream contents.

	self subProcesses do: [:each | each storeOnZip: aZipArchive withFile: aGsFile].! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses
	^subProcesses! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses: newValue
	subProcesses := newValue! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/22/2015 15:54'!
throwNoCreationPermissionExceptionFor: userName

	^NoCreationPermissionException signal: 'The user [', userName, '] has no permission to create instances of this process definition'! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 18:23'!
toggleAnonymousStart

	self isAnonymousStartEnabled ifTrue: [^self removeFromAnonymousStart].

	^self addToAnonymousStart! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 02/12/2016 06:20'!
updateFieldsOf: formInstanceOrStModel
	"The receiver update the dictionary <formFieldInstances> for each field value in the form <formInstanceOrStModel>"

	formInstanceOrStModel fieldValuesDo: [:fieldValueHolder | 
		"is the first time that fields are going to be processed ? (enter in -false- block only once)"
		fieldValueHolder alreadyAddedToProcessDefinition 
		ifFalse: [fieldValueHolder alreadyAddedToProcessDefinition: true.
					fieldValueHolder currentValues do: [:each | self addTo: formInstanceOrStModel getObjectName fieldValue: each]]
		ifTrue: [
			fieldValueHolder hasElementsToAdd 
			ifTrue: [fieldValueHolder fieldsToAddDo: [:fieldValue |
				self addTo: formInstanceOrStModel getObjectName fieldValue: fieldValue]].

			fieldValueHolder hasElementsToRemove 
			ifTrue: [fieldValueHolder fieldsToRemoveDo: [:fieldValue |
				self removeFrom: formInstanceOrStModel getObjectName fieldValue: fieldValue]].
		].
	].! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
version
	^version! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
version: newValue
	version := newValue! !

!BpmProcessDefinition methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 12:21'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString
	^xmlString! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString: newValue
	xmlString := newValue! !

BpmProcessDefinition subclass: #BpmSubProcessDefinition
	instanceVariableNames: 'parentProcess triggeredByEvent isEmbedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:49'!
getParentProcessName

	^parentProcess processName! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 09:56'!
getParentSubProcessTaskDefinition
	"Answer a <aBpmSubProcessTaskDefinition> that created the receiver"

	^parentProcess getSubProcessTasks detect: [:each | each subProcessDefinition == self] ifNone: [nil]! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 10:59'!
getParentTopSubProcessTaskDefinition
	"Answer the Top <BpmSubProcessTaskDefinition> that initiated the creation of the receiver"

	^self getParentSubProcessTaskDefinition
		ifNil: [nil]
		ifNotNil: [:taskDef | 
						taskDef processDefinition isTopProcess
						ifTrue: [taskDef]
						ifFalse: [taskDef processDefinition getParentTopSubProcessTaskDefinition]
		].! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 18:50'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subProcesses do: [:each | each getProcessTree: anOrderedCollection].

	parentProcess getProcessTree: anOrderedCollection.

	^anOrderedCollection! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:20'!
getTopProcess

	^parentProcess getTopProcess! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 15:25'!
initialize

	super initialize.

	triggeredByEvent := false.

	isEmbedded := false.! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 15:24'!
isEmbedded
	^isEmbedded! !

!BpmSubProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 15:24'!
isEmbedded: newValue
	isEmbedded := newValue! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 15:25'!
isReusable

	^isEmbedded not! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
isSubProcess

	^true! !

!BpmSubProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:33'!
parentProcess
	^parentProcess! !

!BpmSubProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:33'!
parentProcess: newValue
	parentProcess := newValue! !

!BpmSubProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:28'!
triggeredByEvent
	^triggeredByEvent! !

!BpmSubProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:28'!
triggeredByEvent: newValue
	triggeredByEvent := newValue! !

BpmProcessDefinition subclass: #BpmTopProcessDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 17:30'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	^executionPath canBeStartedByAnonymousForm! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:49'!
getParentProcessName

	^''! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 09:42'!
getParentSubProcessTaskDefinition
	"Answer a <aBpmSubProcessTaskDefinition> that created the receiver"

	^nil! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 10:59'!
getParentTopSubProcessTaskDefinition
	"Answer the Top <BpmSubProcessTaskDefinition> that initiated the creation of the receiver"

	^nil! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 18:50'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subProcesses do: [:each | each getProcessTree: anOrderedCollection].

	^anOrderedCollection! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:20'!
getTopProcess
	^self! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:36'!
isTopProcess

	^true! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:36'!
parentProcess
	^nil! !

BpmObject subclass: #BpmProcessPathDefinition
	instanceVariableNames: 'processDefinition transitions startEvent intermediateEvents endEvents tasks gateways subProcessTasks scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessPathDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:12'!
definition: aBpmProcessDefinition

	^super new initialize
			processDefinition: aBpmProcessDefinition;
			yourself! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addEndEvent: aBpmEndEventDefinition

	^endEvents at: aBpmEndEventDefinition name put: aBpmEndEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addGateway: aBpmGatewayDefinition

	^gateways at: aBpmGatewayDefinition name put: aBpmGatewayDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addIntermediateEvent: aBpmIntermediateEventDefinition

	^endEvents at: aBpmIntermediateEventDefinition name put: aBpmIntermediateEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:42'!
addScript: aBpmScriptTaskDefinition

	^scripts at: aBpmScriptTaskDefinition name put: aBpmScriptTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addSubProcessTask: aBpmSubProcessTaskDefinition

	^subProcessTasks at: aBpmSubProcessTaskDefinition name put: aBpmSubProcessTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:17'!
addTask: aBpmTaskDefinition

	^tasks at: aBpmTaskDefinition name put: aBpmTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addTransition: aBpmTransitionDefinition

	^transitions add: aBpmTransitionDefinition! !

!BpmProcessPathDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:44'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	processDefinition isSubProcess ifTrue: [^false].

	^(startEvent outTransitions size = 1) and: [startEvent outTransitions allSatisfy: [:each | each endArtifact isOrbeonTask]]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 12:11'!
canCreateProcess: aBpmUser
	"Answer whether or not the user <aBpmUser> can create a process instance of the receiver"

	aBpmUser ifNil: [^true]. "a process can be create with anonymous user"

	^(startEvent outTransitions collect: [:trDefinition | trDefinition endArtifact]) 
			anySatisfy: [:artifactDefinition | 
									artifactDefinition hasPerformers "if has performers --> only the first can create the process instance"
									ifFalse: [artifactDefinition isGrantedUser: aBpmUser]
									ifTrue: [aBpmUser includesRoleNamed: artifactDefinition getFirstPerformerName]
			]! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents
	^endEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents: newValue
	endEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways
	^gateways! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways: newValue
	gateways := newValue! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 06/22/2016 11:44'!
getAllArtifacts

	^(OrderedCollection with: startEvent),
			tasks asOrderedCollection,
			gateways asOrderedCollection,
			intermediateEvents asOrderedCollection,
			subProcessTasks asOrderedCollection,
			scripts asOrderedCollection,
			endEvents asOrderedCollection! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 07:55'!
getAllFieldNames

	^tasks inject: OrderedCollection new into: [:all :each | all addAll: each getFieldNames. all]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:49'!
getAllRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"
	| allRoles |

	allRoles := OrderedCollection new.

	tasks do: [:each | allRoles addAll: each roles].

	^allRoles! !

!BpmProcessPathDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:39'!
getAnonymousFormName
	"Answer the name of the anonymous form"
	| taskDefinition |

	self canBeStartedByAnonymousForm 
	ifFalse: [^NoAnonymousStartException signal: 'This process can NOT be started by an anonymous form'].

	taskDefinition := startEvent outTransitions last endArtifact.

	^taskDefinition applicationName, '.', taskDefinition name! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getEndEventNamed: aString ifNone: aBlock

	^endEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getGatewayNamed: aString ifNone: aBlock

	^gateways at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getIntermediateEventNamed: aString ifNone: aBlock

	^intermediateEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfEndEvents

	^endEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfGateways

	^gateways size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfIntermediateEvents

	^intermediateEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 06/24/2016 09:36'!
getNumberOfScripts

	^scripts size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfSubProcessTasks

	^subProcessTasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTasks

	^tasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTransitions

	^transitions size! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/04/2016 10:42'!
getOrbeonTasks

	^self getAllArtifacts select: [:each | each isOrbeonTask]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:09'!
getOrderedTasks

	^self getOrderedTasksFrom: startEvent as: OrderedCollection new! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:21'!
getOrderedTasksFrom: anArtifactDefinition as: anOrderedCollection
	| newArtifacts |

	newArtifacts := anArtifactDefinition outTransitions collect: [:each | each endArtifact].
	newArtifacts := newArtifacts difference: anOrderedCollection.

	anOrderedCollection addAll: (newArtifacts select: [:each | each isTaskDefinition]).

	newArtifacts do: [:each | self getOrderedTasksFrom: each as: anOrderedCollection].

	^anOrderedCollection! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 06/22/2016 11:45'!
getScriptNamed: aString ifNone: aBlock

	^scripts at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getSubProcessTaskNamed: aString ifNone: aBlock

	^subProcessTasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getTaskNamed: aString ifNone: aBlock

	^tasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/30/2015 05:44'!
getTransitionNamed: aString ifNone: aBlock

	^transitions detect: [:each | each name = aString] ifNone: aBlock! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:19'!
hasGatewayConditionIncludingFieldNamed: fieldName
	"Answer whether or not the receiver has a <BpmGatewayDefinition> with condition that includes a field named <fieldName>"

	^gateways anySatisfy: [:each | each hasEvaluationConditionWithFieldNamed: fieldName]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/23/2016 07:26'!
hasOrbeonFormNamed: aString
	"The receiver answer whether or not it hold a form <OrbeonFormDefinition> named <aString>"

	^(self hasTaskNamed: aString) and: [(self getTaskNamed: aString ifNone: [^false]) isOrbeonTask]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:43'!
hasScriptNamed: aString

	^self scripts anySatisfy: [:each | each name = aString]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 09:48'!
hasTaskNamed: aString

	^self tasks anySatisfy: [:each | each name = aString]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:40'!
initialize

	super initialize.

	transitions := OrderedCollection new.
	intermediateEvents := Dictionary new.	
	endEvents := Dictionary new.
	tasks := Dictionary new.
	gateways := Dictionary new.
	subProcessTasks := Dictionary new.
	scripts := Dictionary new.! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents
	^intermediateEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents: newValue
	intermediateEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 06/28/2016 12:10'!
printArtifacts
	| stream  |

	stream := WriteStream on: String new.

	self getAllArtifacts do: [:each | 
		each printOn: stream.
		stream nextPutAll: '{', each printRoleNames,'}'.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions
	| stream  |

	stream := WriteStream on: String new.

	transitions do: [:each | 
		each printOn: stream.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition
	^processDefinition! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/22/2016 11:40'!
scripts
	^scripts! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/22/2016 11:40'!
scripts: newValue
	scripts := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent
	^startEvent! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent: newValue
	startEvent := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks
	^subProcessTasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks: newValue
	subProcessTasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks
	^tasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks: newValue
	tasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions
	^transitions! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions: newValue
	transitions := newValue! !

BpmObject subclass: #BpmRole
	instanceVariableNames: 'name users isAdmin application orbeonApplication tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmRole subclass: #BpmBackofficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache: aDictionary

	Cache := aDictionary! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 07:52'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	self cache asOrderedCollection do: [:each | allRols addAll: each].

	^allRols! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 08/05/2016 10:09'!
initializeCache
	| mainRole |

	super initializeCache.

	mainRole := self newNamed: 'admin'.
	mainRole addToCacheInAppName: 'admins';
		isAdmin: true.

	^mainRole! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:27'!
asBackofficeRole

	^self! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:42'!
asFrontofficeRole

	^BpmFrontOfficeRole new
		name: name;
		isAdmin: isAdmin;
		application: application;
		yourself! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^true! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^isAdmin! !

BpmRole subclass: #BpmFrontOfficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache: aDictionary

	Cache := aDictionary! !

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 07:52'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	self cache asOrderedCollection do: [:each | allRols addAll: each].

	^allRols! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 08:12'!
getNumberOfTasksDistributionFor: appName
	| distribution |

	distribution := OrderPreservingDictionary new.
	(self getRolsInAppName: appName) do: [:eachRole | 
		distribution at: eachRole name put: eachRole numberOfTasks].

	^distribution! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 14:52'!
getNumberOfUsersDistributionFor: appName
	| distribution |

	distribution := OrderPreservingDictionary new.
	(self getRolsInAppName: appName) do: [:eachRole | 
		distribution at: eachRole name put: eachRole numberOfUsers].

	^distribution! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 14:37'!
getUnassignedTasksDistributionFor: appName
	| distribution |

	distribution := OrderPreservingDictionary new.
	(self getRolsInAppName: appName) do: [:eachRole | | matrix |
		matrix := BpmRunningTasksMatrix getMatrixForApplicationNamed: eachRole getApplicationName.
		distribution at: eachRole name put: (matrix getAvailableTasksFor: eachRole name) size].

	^distribution! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 08:11'!
reportNumberOfTasksDistributionFor: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getNumberOfTasksDistributionFor: appName].
 
	^(BpmRoleDistributionReport applicationName: appName roleName: nil distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 14:38'!
reportNumberOfUnassignedTasksFor: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getUnassignedTasksDistributionFor: appName].
 
	^(BpmRoleDistributionReport applicationName: nil roleName: nil distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself! !

!BpmFrontOfficeRole class methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 14:53'!
reportNumberOfUsersDistributionFor: appName
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getNumberOfUsersDistributionFor: appName].
 
	^(BpmRoleDistributionReport applicationName: appName roleName: nil distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself! !

!BpmFrontOfficeRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:42'!
asBackofficeRole

	^BpmBackofficeRole new
		name: name;
		isAdmin: isAdmin;
		application: application;
		yourself! !

!BpmFrontOfficeRole methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:27'!
asFrontofficeRole

	^self! !

!BpmFrontOfficeRole methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 09:02'!
getAverageTimeForTasks
	| distribution totalTime |

	distribution := OrderPreservingDictionary new.
	totalTime := 0.
	self tasks do: [:task | 
		distribution at: task name put: (task processDefinition getAverageTimeForTaskNamed: task name) asSeconds.
	].

	^distribution! !

!BpmFrontOfficeRole methodsFor: 'distribution' stamp: 'BrunoBB 11/08/2016 09:04'!
reportAverageTimeDistributionForAllTasks
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForTasks].
 
	^(BpmRoleDistributionReport applicationName: self getApplicationName roleName: self name distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:11'!
createNewOrGetExisting: roleName in: appName
	"The receiver creates a new <BpmRole> named <roleName> or get the existing role from OrbeonApplication <appName>"

	^(self getRoleNamed: roleName in: appName)
		ifNotNil: [:bpmRole | bpmRole]
		ifNil: [(self newNamed: roleName) addToCacheInAppName: appName].! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:49'!
getAllRoles
	"Answer a collection with all roles all caches (frontoffice and backoffice)"
	| allRols |

	allRols := OrderedCollection new.

	(BpmFrontOfficeRole cache asOrderedCollection, BpmBackofficeRole cache asOrderedCollection) 
	do: [:each | allRols addAll: each].

	^allRols! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:45'!
getAnyRoleNamed: aString
	"Answer the first role named <aString> "

	^self getAllRoles detect: [:each | each name = aString] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:44'!
getRoleNamed: roleName in: appName
	"Answer a proper instance of receiver's subclass for role named <roleName> in application named <appName>"

	(self cache includesKey: appName) ifFalse: [^nil].

	^(self cache at: appName) detect: [:each | each name = roleName] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:46'!
getRolsInApp: anAbstractApplication
	"Answer a collection with all roles for application <anAbstractApplication> (BpmApplication or OrbeonApplication)"

	^self getAllRoles select: [:each | each application == anAbstractApplication]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:46'!
getRolsInAppName: appName
	"Answer a collection with all roles for application named <appName> (BpmApplication or OrbeonApplication)"

	^(self getAllRoles select: [:each | each getApplicationName = appName]) asOrderedCollection! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:48'!
hasRoleNamed: aString in: anAbstractApplication
	"Answer whether or not the receiver has a role named <aString> in the Application <anAbstractApplication> (BpmApplication or OrbeonApplication)"

	^((self getRolsInApp: anAbstractApplication) select: [:each | each name = aString]) notEmpty! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 08:21'!
initializeCache

	self cache: RcKeyValueDictionary new! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:43'!
newNamed: aString

	^super new initialize
			name: aString;
			yourself! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:32'!
addResponsibility: aBpmArtifactDefinition

	^tasks at: aBpmArtifactDefinition name put: aBpmArtifactDefinition! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:21'!
addToCacheInAppName: aString
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"
	| roleCollection |

	application := self getApplicationManagerClass getAnyApplicationNamed: aString ifNone: [^NoApplicationException signal: 'No Orbeon Application named <', aString, '>'].

	"get the role's collection for the OrbeonApplication named <aString>"
	(self class cache includesKey: aString) ifFalse: [self class cache at: aString put: RcIdentityBag new].

	roleCollection := self class cache at: aString. 

	"NOT possible to add two roles with the same name"
	^roleCollection detect: [:each | name = each name] ifNone: [roleCollection add: self].! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 14:39'!
application
	^application! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 14:39'!
application: newValue
	application := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 15:50'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^tasks isEmpty and: [users isEmpty]! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:39'!
getApplicationName

	^application applicationName! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:46'!
getProcessDefinitions
	"Answer a collection of <BpmProcessDefinition> where the receiver perform at least one task"! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:28'!
grantUser: aBpmUser
	"The user <aBpmUser> is granted in the receiver"

	users at: aBpmUser username put: aBpmUser.

	^aBpmUser addRole: self! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:32'!
initialize

	super initialize.

	name := ''.
	users := Dictionary new.
	tasks := Dictionary new.
	isAdmin := false.! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin
	^isAdmin! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin: newValue
	isAdmin := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^false! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^false! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:48'!
isGranted: aBpmUser

	^users includes: aBpmUser! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
name
	^name! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
name: newValue
	name := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 08:03'!
numberOfTasks

	^tasks size! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 14:53'!
numberOfUsers

	^users size! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication
	^orbeonApplication! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:37'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:04'!
removeAllUsers
	"The receiver ungrant all users"
	| allUsers |

	allUsers := OrderedCollection withAll: users.

	allUsers do: [:each | self ungrantUser: each].! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:23'!
removeFromCache
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"

	^self removeFromCacheInAppName: application applicationName! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 12:58'!
removeFromCacheInAppName: aString
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"

	application := self getApplicationManagerClass getAnyApplicationNamed: aString ifNone: [^NoApplicationException signal: 'No Application named <', aString, '>'].

	^(self class cache at: aString) remove: self ifAbsent: [^NoSuchRoleException signal: 'No Role named <', name, '>'].! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:19'!
removeResponsibility: aBpmArtifactDefinition

	^tasks removeKey: aBpmArtifactDefinition name 
				ifAbsent: [NoSuchActivitytException signal: 'No such Activity Definition in [', aBpmArtifactDefinition name, ']']! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks
	^tasks! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks: newValue
	tasks := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 16:29'!
ungrantUser: aBpmUser

	users removeKey: aBpmUser username ifAbsent: [].

	^aBpmUser removeRole: self! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
users
	^users! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
users: newValue
	users := newValue! !

BpmObject subclass: #BpmTaskLoop
	instanceVariableNames: 'taskDefinition startQuantity completionQuantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTaskLoop subclass: #BpmMultiInstanceTaskLoop
	instanceVariableNames: 'loopCardinality isSequential'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmMultiInstanceTaskLoop commentStamp: 'BrunoBB 10/31/2015 10:59' prior: 0!
Multinstance - each time a transition trigger the a task --> a new instance of the <externalObject> is created.

loopCardinality - anInteger expression!

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 11:01'!
initialize

	super initialize.

	loopCardinality := nil. "anInteger expression"
	isSequential := true. "false --> instances are created in parralel"! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^true! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential
	^isSequential! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential: newValue
	isSequential := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality
	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality: newValue
	loopCardinality := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	loopCardinality := aStringBlock! !

BpmTaskLoop subclass: #BpmNoneTaskLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmNoneTaskLoop commentStamp: '' prior: 0!
None - each time a transition trigger the a task --> the only instance of <externalObject> is edited.!

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^nil! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isNone

	^true! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock! !

BpmTaskLoop subclass: #BpmStandartTaskLoop
	instanceVariableNames: 'loopCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStandartTaskLoop commentStamp: 'BrunoBB 10/31/2015 11:02' prior: 0!
Standart - each time a transition trigger the a task --> the only instance of <externalObject> is edited.

loopCondition - aBoolean expression!

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isStandart

	^true! !

!BpmStandartTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition
	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition: newValue
	loopCondition := newValue! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock

	loopCondition := aStringBlock! !

!BpmTaskLoop class methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
for: aBpmTaskDefinition

	^super new initialize
		taskDefinition: aBpmTaskDefinition;
		yourself! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity
	^completionQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity: newValue
	completionQuantity := newValue! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 10:10'!
initialize

	super initialize.

	startQuantity := 1.
	completionQuantity := 1.! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isNone

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isStandart

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
startQuantity
	^startQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 08:31'!
startQuantity: newValue

	newValue ifNil: [^startQuantity := 1]. "when this value is absent --> it can be assumed that is 1 -one-"

	startQuantity := newValue! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition
	^taskDefinition! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition: newValue
	taskDefinition := newValue! !

BpmObject subclass: #BpmTransitionDefinition
	instanceVariableNames: 'processDefinition name startArtifact endArtifact conditionToRun extendedAttributes isDefaultFlow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTransitionDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:46'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:31'!
addToParentProcess

	^processDefinition addTransition: self! !

!BpmTransitionDefinition methodsFor: 'condition evaluation' stamp: 'BrunoBB 07/02/2016 11:46'!
basicEvaluateConditionIn: aBpmProcessInstance
	"The receiver evaluates the condition <conditionToRun> in the context of the object <aBpmProcessInstance>"

	^conditionToRun evaluateConditionIn: aBpmProcessInstance.! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun
	^conditionToRun! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun: newValue
	conditionToRun := newValue! !

!BpmTransitionDefinition methodsFor: 'svg' stamp: 'BrunoBB 12/06/2016 04:24'!
drawOn: aJasvgiBpmCanvas
	| transition coordinates |

	coordinates := OrderedCollection new.
	startArtifact isTaskDefinition ifTrue: [coordinates add: 160@40] ifFalse: [coordinates add: 50@40].
	endArtifact isTaskDefinition ifTrue: [coordinates add: 250@40] ifFalse: [coordinates add: 250@40].	

	transition := aJasvgiBpmCanvas 
						connectWith: coordinates asArray
						color: 'black'
						widthPx: '1px'.

	aJasvgiBpmCanvas addMarker: (JASVGIObject markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).

	transition setMarkerEnd: 'arrow'.

	endArtifact roles ifNotEmpty:[:collection | aJasvgiBpmCanvas drawText: ('Rol: ', collection last name) at: 0@15 textSizePx: '15px' color: 'darkBlue'].

	aJasvgiBpmCanvas drawText: self printConditionToRun at: 5@30 textSizePx: '12px'.! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact
	^endArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact: newValue
	endArtifact := newValue! !

!BpmTransitionDefinition methodsFor: 'condition evaluation' stamp: 'BrunoBB 07/02/2016 11:47'!
evaluateConditionIn: aBpmProcessInstance
	"The receiver evaluates the condition <conditionToRun> in the context of the object <aBpmProcessInstance>"
	| evaluationResult |

	evaluationResult := self basicEvaluateConditionIn: aBpmProcessInstance.

	evaluationResult hasException
	ifTrue: [evaluationResult addToCache].

	^evaluationResult result! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedAttributes
	^extendedAttributes! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedAttributes: newValue
	extendedAttributes := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedValueOf: attrName

	^extendedAttributes at: attrName ifAbsent: [nil]! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedValueOf: attrName ifAbsent: aBlock

	^extendedAttributes at: attrName ifAbsent: aBlock! !

!BpmTransitionDefinition methodsFor: 'condition evaluation' stamp: 'BrunoBB 07/02/2016 12:12'!
hasCondition

	^conditionToRun hasEvaluation! !

!BpmTransitionDefinition methodsFor: 'condition evaluation' stamp: 'BrunoBB 04/19/2016 16:20'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"

	^conditionToRun hasEvaluationConditionWithFieldNamed: fieldName! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/30/2016 10:22'!
initialize

	super initialize.

	extendedAttributes := Dictionary new.
	isDefaultFlow := false! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/30/2016 10:21'!
isDefaultFlow
	^isDefaultFlow! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 06/30/2016 10:21'!
isDefaultFlow: newValue
	isDefaultFlow := newValue! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 13:55'!
name
	^name! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 13:55'!
name: newValue
	name := newValue! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 06/18/2016 11:36'!
printConditionToRun
	
	conditionToRun ifNil: [^''].

	^conditionToRun evaluationCode! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 06/16/2016 14:05'!
printData
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: (startArtifact name, ' > ', endArtifact name), String lf.

	^stream contents! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 15:33'!
printEndArtifactName

	^endArtifact name! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:35'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, '] {(', startArtifact printOnType, ')',startArtifact name, '} >> {(', endArtifact printOnType, ')', endArtifact name, '}'.! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 06/18/2016 15:34'!
printStartArtifactName

	^startArtifact name! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition
	^processDefinition! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
removeExtendedAttribute: attrName 

	^extendedAttributes removeKey: attrName ifAbsent: []! !

!BpmTransitionDefinition methodsFor: 'condition evaluation' stamp: 'BrunoBB 10/29/2015 13:11'!
setCondition: aString

	conditionToRun := BpmCodeCondition code: aString! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setEndArtifact: aBpmArtifactDefinition

	endArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addInTransition: self! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
setExtended: attrName value: anObject

	^extendedAttributes at: attrName put: anObject! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setStartArtifact: aBpmArtifactDefinition

	startArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addOutTransition: self! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact
	^startArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact: newValue
	startArtifact := newValue! !

BpmObject subclass: #BpmUserGrantConfiguration
	instanceVariableNames: 'user application role'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmUserGrantConfiguration class methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:07'!
for: aBpmUser app: anApplication role: aBpmRole

	^super new initialize
		user: aBpmUser;
		role: aBpmRole;
		application: anApplication;
		yourself! !

!BpmUserGrantConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 06/19/2016 13:06'!
application
	^application! !

!BpmUserGrantConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 06/19/2016 13:06'!
application: newValue
	application := newValue! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:11'!
applicationName

	^application applicationName! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 14:36'!
applicationType

	^application class name! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 15:05'!
applyConfiguration

	role addToCacheInAppName: self applicationName.

	role grantUser: user! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 16:53'!
printApplicationType

	^(application class == BpmApplication) ifTrue: ['B'] ifFalse: ['O']! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 16:54'!
printRoleType

	^(role class == BpmBackofficeRole) ifTrue: ['B'] ifFalse: ['F']! !

!BpmUserGrantConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 06/19/2016 13:06'!
role
	^role! !

!BpmUserGrantConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 06/19/2016 13:06'!
role: newValue
	role := newValue! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:11'!
roleName

	^role name! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 14:36'!
roleType

	^role class name! !

!BpmUserGrantConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 06/19/2016 13:06'!
user
	^user! !

!BpmUserGrantConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 06/19/2016 13:06'!
user: newValue
	user := newValue! !

!BpmUserGrantConfiguration methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:10'!
username

	^user username! !

!Object class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/08/2016 13:40'!
getBpmApplicationClass
	"The receiver answer the class used as Bpm applications holder"

	^BpmApplication! !

!Object class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/26/2016 13:46'!
getBpmCache
	"The receiver answer the class used as Bpm applications holder"

	^AbstractApplication getBpmCache! !

!Object methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/08/2016 13:41'!
getBpmApplicationClass
	"The receiver answer the class used as Bpm applications holder"

	^self class getBpmApplicationClass! !

!Object methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/26/2016 13:47'!
getBpmCache

	^self class getBpmCache! !

!TimeStamp methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/03/2017 04:53'!
hours

	^self time hours! !

!AppDistributionReport class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 11/19/2016 06:22'!
getBpmReportClasses

	^OrderedCollection new
		add: AppGlobalDistributionReport;
		add: BpmApplicationDistributionReport;
		add: BpmProcessDistributionReport;
		add: BpmFieldDistributionReport;
		add: BpmRecursiveFieldDistributionReport;
		add: BpmRoleDistributionReport;
		add: BpmUserDistributionReport;
		yourself! !

!AppDistributionReport class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 11/19/2016 06:23'!
getBpmReportNames

	^self getBpmReportClasses collect: [:each | each getComboName]! !

!AbstractApplication methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/29/2016 10:02'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^(BpmBackofficeRole getRolsInAppName: applicationName) isEmpty and: [
		(BpmFrontOfficeRole getRolsInAppName: applicationName) isEmpty and: [
		(BpmProcessDefinition hasAnyProcessApplicationNamed: applicationName) not
		]]! !

AbstractApplication subclass: #BpmApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:23'!
applicationNamed: aString ifNone: aBlock
	"Answer an OrbeonApplication or BpmApplication named <aString> if none evaluates the zero block argument <aBlock>"

	^self getBpmCache detect: [:each | each applicationName = aString] ifNone: aBlock! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 16:32'!
getApplicationNameForCombo

	^applicationName , ' [BpmApp]'! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:23'!
getLastDefinitions
	"No Orbeon definitions - for compability with Orbeon integration"

	^Dictionary new! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 04/21/2016 12:58'!
hasReadAccess: anOrbeonUser
	"Implemented for compability with Orbeon package !!!!!!.
	Answer whether or not the user <anOrbeonUser> has read permission over the receiver.
	If an user has read permission over a definition then has read access over the application (the receiver)"

	^false! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 11:49'!
isBpmApplication

	^true! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 12:02'!
printType

	^'Bpm'! !

AppLocalDistributionReport subclass: #BpmApplicationDistributionReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmApplicationDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:19'!
getComboName

	^'Application Report'! !

!BpmApplicationDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 09:00'!
isApplication

	^true! !

AppLocalDistributionReport subclass: #BpmProcessDistributionReport
	instanceVariableNames: 'processName version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmProcessDistributionReport subclass: #BpmFieldDistributionReport
	instanceVariableNames: 'formName fieldName secondaryField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmFieldDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:19'!
getComboName

	^'Field Report'! !

!BpmFieldDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/06/2016 07:47'!
fieldName
	^fieldName! !

!BpmFieldDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/06/2016 07:47'!
fieldName: newValue
	fieldName := newValue! !

!BpmFieldDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/06/2016 07:47'!
formName
	^formName! !

!BpmFieldDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/06/2016 07:47'!
formName: newValue
	formName := newValue! !

!BpmFieldDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/20/2016 10:51'!
getDescriptionItems

	^super getDescriptionItems
		at: 'Form:' put: formName;
		at: 'Field:' put: fieldName;
		at: 'Secondary Field:' put: secondaryField;
		yourself! !

!BpmFieldDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 03:18'!
isField

	^true! !

!BpmFieldDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/06/2016 07:47'!
secondaryField
	^secondaryField! !

!BpmFieldDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/06/2016 07:47'!
secondaryField: newValue
	secondaryField := newValue! !

BpmFieldDistributionReport subclass: #BpmRecursiveFieldDistributionReport
	instanceVariableNames: 'subDistributionMethods subDistributions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmRecursiveFieldDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:19'!
getComboName

	^'Recursive Field Report'! !

!BpmRecursiveFieldDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/06/2016 07:54'!
addSubDistribution: aDictionary

	^subDistributions add: aDictionary! !

!BpmRecursiveFieldDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/06/2016 07:54'!
getFirstSubDistribution

	^subDistributions first! !

!BpmRecursiveFieldDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/06/2016 07:54'!
initialize

	super initialize.

	subDistributionMethods := OrderedCollection new.
	subDistributions := OrderedCollection new.! !

!BpmRecursiveFieldDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/06/2016 07:54'!
subDistributionMethods
	^subDistributionMethods! !

!BpmRecursiveFieldDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/06/2016 07:54'!
subDistributionMethods: newValue
	subDistributionMethods := newValue! !

!BpmRecursiveFieldDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/06/2016 07:54'!
subDistributions
	^subDistributions! !

!BpmRecursiveFieldDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/06/2016 07:54'!
subDistributions: newValue
	subDistributions := newValue! !

!BpmProcessDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:19'!
getComboName

	^'Process Report'! !

!BpmProcessDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/02/2016 08:28'!
processName: processName applicationName: applicationName distribution: aDictionary

	^(super applicationName: applicationName distribution: aDictionary)
			processName: processName;
			yourself! !

!BpmProcessDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/20/2016 10:51'!
getDescriptionItems

	^super getDescriptionItems
		at: 'Process:' put: processName;
		at: 'Version:' put: version;
		yourself! !

!BpmProcessDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/02/2016 07:50'!
initialize

	super initialize.

	isAllVersions := true.! !

!BpmProcessDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/18/2016 03:19'!
isAllVersions

	^version isNil! !

!BpmProcessDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/19/2016 09:25'!
isProcess

	^true! !

!BpmProcessDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/02/2016 07:49'!
processName
	^processName! !

!BpmProcessDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2016 07:49'!
processName: newValue
	processName := newValue! !

!BpmProcessDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/18/2016 03:19'!
version
	^version! !

!BpmProcessDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/18/2016 03:19'!
version: newValue
	version := newValue! !

AppLocalDistributionReport subclass: #BpmRoleDistributionReport
	instanceVariableNames: 'roleName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmRoleDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 08:06'!
applicationName: applicationName roleName: roleName distribution: aDictionary

	^(super distribution: aDictionary)
		applicationName: applicationName;
		roleName: roleName;
		yourself! !

!BpmRoleDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:19'!
getComboName

	^'Role Report'! !

!BpmRoleDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/20/2016 10:51'!
getDescriptionItems

	^super getDescriptionItems
		at: 'Role:' put: roleName;
		yourself! !

!BpmRoleDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/19/2016 09:48'!
isRole

	^true! !

!BpmRoleDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/08/2016 08:06'!
roleName
	^roleName! !

!BpmRoleDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/08/2016 08:06'!
roleName: newValue
	roleName := newValue! !

AppLocalDistributionReport subclass: #BpmUserDistributionReport
	instanceVariableNames: 'userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmUserDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:20'!
getComboName

	^'User Report'! !

!BpmUserDistributionReport class methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:52'!
userName: userName distribution: aDictionary

	^(super distribution: aDictionary)
		userName: userName;
		yourself! !

!BpmUserDistributionReport methodsFor: 'other' stamp: 'BrunoBB 11/20/2016 10:51'!
getDescriptionItems

	^super getDescriptionItems
		at: 'User:' put: userName;
		yourself! !

!BpmUserDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/19/2016 09:48'!
isUser

	^true! !

!BpmUserDistributionReport methodsFor: 'Accessing' stamp: 'BrunoBB 11/08/2016 13:51'!
userName
	^userName! !

!BpmUserDistributionReport methodsFor: 'Updating' stamp: 'BrunoBB 11/08/2016 13:51'!
userName: newValue
	userName := newValue! !
